/* Settings.c generated by valac 0.40.0, the Vala compiler
 * generated from Settings.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include "CbTextTransform.h"


#define TYPE_MEDIA_VISIBILITY (media_visibility_get_type ())

#define TYPE_SETTINGS (settings_get_type ())
#define SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SETTINGS, Settings))
#define SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SETTINGS, SettingsClass))
#define IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SETTINGS))
#define IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SETTINGS))
#define SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SETTINGS, SettingsClass))

typedef struct _Settings Settings;
typedef struct _SettingsClass SettingsClass;
typedef struct _SettingsPrivate SettingsPrivate;
enum  {
	SETTINGS_0_PROPERTY,
	SETTINGS_NUM_PROPERTIES
};
static GParamSpec* settings_properties[SETTINGS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	MEDIA_VISIBILITY_SHOW = 1,
	MEDIA_VISIBILITY_HIDE = 2,
	MEDIA_VISIBILITY_HIDE_IN_TIMELINES = 3
} MediaVisibility;

struct _Settings {
	GObject parent_instance;
	SettingsPrivate * priv;
};

struct _SettingsClass {
	GObjectClass parent_class;
};


static gpointer settings_parent_class = NULL;
static GSettings* settings_settings;
static GSettings* settings_settings = NULL;

GType media_visibility_get_type (void) G_GNUC_CONST;
GType settings_get_type (void) G_GNUC_CONST;
void settings_init (void);
GSettings* settings_get (void);
gint settings_get_tweet_stack_count (void);
gboolean settings_use_dark_theme (void);
gboolean settings_notify_new_mentions (void);
gboolean settings_notify_new_dms (void);
gboolean settings_auto_scroll_on_new_tweets (void);
gchar* settings_get_accel (const gchar* accel_name);
gdouble settings_max_media_size (void);
void settings_toggle_topbar_visible (void);
gchar* settings_get_consumer_key (void);
gchar* settings_get_consumer_secret (void);
void settings_add_text_transform_flag (CbTransformFlags flag);
void settings_remove_text_transform_flag (CbTransformFlags flag);
CbTransformFlags settings_get_text_transform_flags (void);
gboolean settings_hide_nsfw_content (void);
MediaVisibility settings_get_media_visiblity (void);
Settings* settings_new (void);
Settings* settings_construct (GType object_type);
static void settings_finalize (GObject * obj);


GType
media_visibility_get_type (void)
{
	static volatile gsize media_visibility_type_id__volatile = 0;
	if (g_once_init_enter (&media_visibility_type_id__volatile)) {
		static const GEnumValue values[] = {{MEDIA_VISIBILITY_SHOW, "MEDIA_VISIBILITY_SHOW", "show"}, {MEDIA_VISIBILITY_HIDE, "MEDIA_VISIBILITY_HIDE", "hide"}, {MEDIA_VISIBILITY_HIDE_IN_TIMELINES, "MEDIA_VISIBILITY_HIDE_IN_TIMELINES", "hide-in-timelines"}, {0, NULL, NULL}};
		GType media_visibility_type_id;
		media_visibility_type_id = g_enum_register_static ("MediaVisibility", values);
		g_once_init_leave (&media_visibility_type_id__volatile, media_visibility_type_id);
	}
	return media_visibility_type_id__volatile;
}


void
settings_init (void)
{
	GSettings* _tmp0_;
	_tmp0_ = g_settings_new ("org.baedert.corebird");
	_g_object_unref0 (settings_settings);
	settings_settings = _tmp0_;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


GSettings*
settings_get (void)
{
	GSettings* result = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	_tmp0_ = settings_settings;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}


/**
   * Returns how many tweets should be stacked before a
   * notification should be created.
   */
gint
settings_get_tweet_stack_count (void)
{
	gint result = 0;
	gint setting_val = 0;
	GSettings* _tmp0_;
	_tmp0_ = settings_settings;
	setting_val = g_settings_get_enum (_tmp0_, "new-tweets-notify");
	result = setting_val;
	return result;
}


/**
  * Check whether the user wants Corebird to always use the dark gtk theme variant.
  */
gboolean
settings_use_dark_theme (void)
{
	gboolean result = FALSE;
	GSettings* _tmp0_;
	_tmp0_ = settings_settings;
	result = g_settings_get_boolean (_tmp0_, "use-dark-theme");
	return result;
}


gboolean
settings_notify_new_mentions (void)
{
	gboolean result = FALSE;
	GSettings* _tmp0_;
	_tmp0_ = settings_settings;
	result = g_settings_get_boolean (_tmp0_, "new-mentions-notify");
	return result;
}


gboolean
settings_notify_new_dms (void)
{
	gboolean result = FALSE;
	GSettings* _tmp0_;
	_tmp0_ = settings_settings;
	result = g_settings_get_boolean (_tmp0_, "new-dms-notify");
	return result;
}


gboolean
settings_auto_scroll_on_new_tweets (void)
{
	gboolean result = FALSE;
	GSettings* _tmp0_;
	_tmp0_ = settings_settings;
	result = g_settings_get_boolean (_tmp0_, "auto-scroll-on-new-tweets");
	return result;
}


gchar*
settings_get_accel (const gchar* accel_name)
{
	gchar* result = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	g_return_val_if_fail (accel_name != NULL, NULL);
	_tmp0_ = settings_settings;
	_tmp1_ = g_strconcat ("accel-", accel_name, NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_settings_get_string (_tmp0_, _tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}


gdouble
settings_max_media_size (void)
{
	gdouble result = 0.0;
	GSettings* _tmp0_;
	_tmp0_ = settings_settings;
	result = g_settings_get_double (_tmp0_, "max-media-size");
	return result;
}


void
settings_toggle_topbar_visible (void)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	_tmp0_ = settings_settings;
	_tmp1_ = settings_settings;
	g_settings_set_boolean (_tmp0_, "sidebar-visible", !g_settings_get_boolean (_tmp1_, "sidebar-visible"));
}


gchar*
settings_get_consumer_key (void)
{
	gchar* result = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = settings_settings;
	_tmp1_ = g_settings_get_string (_tmp0_, "consumer-key");
	result = _tmp1_;
	return result;
}


gchar*
settings_get_consumer_secret (void)
{
	gchar* result = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = settings_settings;
	_tmp1_ = g_settings_get_string (_tmp0_, "consumer-secret");
	result = _tmp1_;
	return result;
}


void
settings_add_text_transform_flag (CbTransformFlags flag)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	_tmp0_ = settings_settings;
	_tmp1_ = settings_settings;
	g_settings_set_uint (_tmp0_, "text-transform-flags", g_settings_get_uint (_tmp1_, "text-transform-flags") | flag);
}


void
settings_remove_text_transform_flag (CbTransformFlags flag)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	_tmp0_ = settings_settings;
	_tmp1_ = settings_settings;
	g_settings_set_uint (_tmp0_, "text-transform-flags", g_settings_get_uint (_tmp1_, "text-transform-flags") & (~flag));
}


CbTransformFlags
settings_get_text_transform_flags (void)
{
	CbTransformFlags result = 0;
	GSettings* _tmp0_;
	_tmp0_ = settings_settings;
	result = (CbTransformFlags) g_settings_get_uint (_tmp0_, "text-transform-flags");
	return result;
}


gboolean
settings_hide_nsfw_content (void)
{
	gboolean result = FALSE;
	GSettings* _tmp0_;
	_tmp0_ = settings_settings;
	result = g_settings_get_boolean (_tmp0_, "hide-nsfw-content");
	return result;
}


MediaVisibility
settings_get_media_visiblity (void)
{
	MediaVisibility result = 0;
	GSettings* _tmp0_;
	_tmp0_ = settings_settings;
	result = (MediaVisibility) g_settings_get_enum (_tmp0_, "media-visibility");
	return result;
}


Settings*
settings_construct (GType object_type)
{
	Settings * self = NULL;
	self = (Settings*) g_object_new (object_type, NULL);
	return self;
}


Settings*
settings_new (void)
{
	return settings_construct (TYPE_SETTINGS);
}


static void
settings_class_init (SettingsClass * klass)
{
	settings_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = settings_finalize;
}


static void
settings_instance_init (Settings * self)
{
}


static void
settings_finalize (GObject * obj)
{
	Settings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SETTINGS, Settings);
	G_OBJECT_CLASS (settings_parent_class)->finalize (obj);
}


GType
settings_get_type (void)
{
	static volatile gsize settings_type_id__volatile = 0;
	if (g_once_init_enter (&settings_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Settings), 0, (GInstanceInitFunc) settings_instance_init, NULL };
		GType settings_type_id;
		settings_type_id = g_type_register_static (G_TYPE_OBJECT, "Settings", &g_define_type_info, 0);
		g_once_init_leave (&settings_type_id__volatile, settings_type_id);
	}
	return settings_type_id__volatile;
}



