/* AspectImage.c generated by valac 0.40.0, the Vala compiler
 * generated from AspectImage.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_ASPECT_IMAGE (aspect_image_get_type ())
#define ASPECT_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ASPECT_IMAGE, AspectImage))
#define ASPECT_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ASPECT_IMAGE, AspectImageClass))
#define IS_ASPECT_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ASPECT_IMAGE))
#define IS_ASPECT_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ASPECT_IMAGE))
#define ASPECT_IMAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ASPECT_IMAGE, AspectImageClass))

typedef struct _AspectImage AspectImage;
typedef struct _AspectImageClass AspectImageClass;
typedef struct _AspectImagePrivate AspectImagePrivate;
enum  {
	ASPECT_IMAGE_0_PROPERTY,
	ASPECT_IMAGE_PIXBUF_PROPERTY,
	ASPECT_IMAGE_COLOR_STRING_PROPERTY,
	ASPECT_IMAGE_NUM_PROPERTIES
};
static GParamSpec* aspect_image_properties[ASPECT_IMAGE_NUM_PROPERTIES];
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))

struct _AspectImage {
	GtkWidget parent_instance;
	AspectImagePrivate * priv;
};

struct _AspectImageClass {
	GtkWidgetClass parent_class;
};

struct _AspectImagePrivate {
	GdkRGBA bg_color;
	cairo_surface_t* old_surface;
	cairo_surface_t* pixbuf_surface;
	gdouble alpha;
	gint64 start_time;
	gboolean in_transition;
};


static gpointer aspect_image_parent_class = NULL;
extern GdkPixbuf* twitter_no_banner;

GType aspect_image_get_type (void) G_GNUC_CONST;
#define ASPECT_IMAGE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ASPECT_IMAGE, AspectImagePrivate))
AspectImage* aspect_image_new (void);
AspectImage* aspect_image_construct (GType object_type);
static void aspect_image_start_animation (AspectImage* self);
static gboolean aspect_image_fade_in_cb (AspectImage* self,
                                  GtkWidget* widget,
                                  GdkFrameClock* frame_clock);
static gboolean _aspect_image_fade_in_cb_gtk_tick_callback (GtkWidget* widget,
                                                     GdkFrameClock* frame_clock,
                                                     gpointer self);
#define TRANSITION_DURATION (200 * 1000)
gdouble ease_out_cubic (gdouble t);
static void aspect_image_real_get_preferred_height_for_width (GtkWidget* base,
                                                       gint width,
                                                       gint* min_height,
                                                       gint* nat_height);
static GtkSizeRequestMode aspect_image_real_get_request_mode (GtkWidget* base);
static gboolean aspect_image_real_draw (GtkWidget* base,
                                 cairo_t* ct);
void aspect_image_set_pixbuf (AspectImage* self,
                              GdkPixbuf* value);
void aspect_image_set_color_string (AspectImage* self,
                                    const gchar* value);
static GObject * aspect_image_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void aspect_image_finalize (GObject * obj);
static void _vala_aspect_image_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);


AspectImage*
aspect_image_construct (GType object_type)
{
	AspectImage * self = NULL;
	self = (AspectImage*) gtk_widget_new (object_type, NULL);
	return self;
}


AspectImage*
aspect_image_new (void)
{
	return aspect_image_construct (TYPE_ASPECT_IMAGE);
}


static gboolean
_aspect_image_fade_in_cb_gtk_tick_callback (GtkWidget* widget,
                                            GdkFrameClock* frame_clock,
                                            gpointer self)
{
	gboolean result;
	result = aspect_image_fade_in_cb ((AspectImage*) self, widget, frame_clock);
	return result;
}


static void
aspect_image_start_animation (AspectImage* self)
{
	GdkFrameClock* _tmp0_;
	g_return_if_fail (IS_ASPECT_IMAGE (self));
	if (!gtk_widget_get_realized (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget))) {
		return;
	}
	self->priv->alpha = 0.0;
	self->priv->in_transition = TRUE;
	_tmp0_ = gtk_widget_get_frame_clock (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	self->priv->start_time = gdk_frame_clock_get_frame_time (_tmp0_);
	gtk_widget_add_tick_callback (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), _aspect_image_fade_in_cb_gtk_tick_callback, g_object_ref (self), g_object_unref);
}


static gboolean
aspect_image_fade_in_cb (AspectImage* self,
                         GtkWidget* widget,
                         GdkFrameClock* frame_clock)
{
	gboolean result = FALSE;
	gint64 now = 0LL;
	gdouble t = 0.0;
	gint64 _tmp0_;
	gint64 _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	g_return_val_if_fail (IS_ASPECT_IMAGE (self), FALSE);
	g_return_val_if_fail (GTK_IS_WIDGET (widget), FALSE);
	g_return_val_if_fail (GDK_IS_FRAME_CLOCK (frame_clock), FALSE);
	now = gdk_frame_clock_get_frame_time (frame_clock);
	_tmp0_ = now;
	_tmp1_ = self->priv->start_time;
	t = ((gdouble) (_tmp0_ - _tmp1_)) / TRANSITION_DURATION;
	_tmp2_ = t;
	if (_tmp2_ >= 1.0) {
		t = 1.0;
		self->priv->in_transition = FALSE;
	}
	_tmp3_ = t;
	self->priv->alpha = ease_out_cubic (_tmp3_);
	gtk_widget_queue_draw (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	_tmp4_ = t;
	result = _tmp4_ < 1.0;
	return result;
}


static void
aspect_image_real_get_preferred_height_for_width (GtkWidget* base,
                                                  gint width,
                                                  gint* min_height,
                                                  gint* nat_height)
{
	AspectImage * self;
	gint _vala_min_height = 0;
	gint _vala_nat_height = 0;
	cairo_surface_t* _tmp0_;
	cairo_surface_t* _tmp1_;
	cairo_surface_t* _tmp2_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ASPECT_IMAGE, AspectImage);
	_tmp0_ = self->priv->pixbuf_surface;
	if (_tmp0_ == NULL) {
		_vala_min_height = 0;
		_vala_nat_height = 1;
		if (min_height) {
			*min_height = _vala_min_height;
		}
		if (nat_height) {
			*nat_height = _vala_nat_height;
		}
		return;
	}
	_tmp1_ = self->priv->pixbuf_surface;
	_vala_min_height = cairo_image_surface_get_height (_tmp1_);
	_tmp2_ = self->priv->pixbuf_surface;
	_vala_nat_height = cairo_image_surface_get_height (_tmp2_);
	if (min_height) {
		*min_height = _vala_min_height;
	}
	if (nat_height) {
		*nat_height = _vala_nat_height;
	}
}


static GtkSizeRequestMode
aspect_image_real_get_request_mode (GtkWidget* base)
{
	AspectImage * self;
	GtkSizeRequestMode result = 0;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ASPECT_IMAGE, AspectImage);
	result = GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH;
	return result;
}


static gboolean
aspect_image_real_draw (GtkWidget* base,
                        cairo_t* ct)
{
	AspectImage * self;
	gboolean result = FALSE;
	gint width = 0;
	gint height = 0;
	gdouble scale_x = 0.0;
	GdkRGBA _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gdouble _tmp7_;
	cairo_surface_t* _tmp8_;
	GdkRGBA _tmp20_;
	gdouble _tmp21_;
	gboolean _tmp35_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ASPECT_IMAGE, AspectImage);
	g_return_val_if_fail (ct != NULL, FALSE);
	width = gtk_widget_get_allocated_width (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	height = gtk_widget_get_allocated_height (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	scale_x = 1.0;
	_tmp0_ = self->priv->bg_color;
	_tmp1_ = _tmp0_.alpha;
	if (_tmp1_ == 0.0) {
		gint _tmp2_;
		cairo_surface_t* _tmp3_;
		_tmp2_ = width;
		_tmp3_ = self->priv->pixbuf_surface;
		scale_x = _tmp2_ / ((gdouble) cairo_image_surface_get_width (_tmp3_));
	}
	_tmp4_ = scale_x;
	scale_x = MAX (_tmp4_, 1.0);
	_tmp5_ = width;
	_tmp6_ = height;
	cairo_rectangle (ct, (gdouble) 0, (gdouble) 0, (gdouble) _tmp5_, (gdouble) _tmp6_);
	_tmp7_ = scale_x;
	cairo_scale (ct, _tmp7_, 1.0);
	cairo_push_group (ct);
	_tmp8_ = self->priv->old_surface;
	if (_tmp8_ != NULL) {
		cairo_surface_t* _tmp9_;
		_tmp9_ = self->priv->old_surface;
		cairo_set_source_surface (ct, _tmp9_, (gdouble) 0, (gdouble) 0);
		cairo_paint (ct);
	} else {
		GdkRGBA _tmp10_;
		gdouble _tmp11_;
		_tmp10_ = self->priv->bg_color;
		_tmp11_ = _tmp10_.alpha;
		if (_tmp11_ > 0.0) {
			GdkRGBA _tmp12_;
			gdouble _tmp13_;
			GdkRGBA _tmp14_;
			gdouble _tmp15_;
			GdkRGBA _tmp16_;
			gdouble _tmp17_;
			GdkRGBA _tmp18_;
			gdouble _tmp19_;
			_tmp12_ = self->priv->bg_color;
			_tmp13_ = _tmp12_.red;
			_tmp14_ = self->priv->bg_color;
			_tmp15_ = _tmp14_.green;
			_tmp16_ = self->priv->bg_color;
			_tmp17_ = _tmp16_.blue;
			_tmp18_ = self->priv->bg_color;
			_tmp19_ = _tmp18_.alpha;
			cairo_set_source_rgba (ct, _tmp13_, _tmp15_, _tmp17_, _tmp19_);
			cairo_fill (ct);
		} else {
			self->priv->alpha = 1.0;
		}
	}
	_tmp20_ = self->priv->bg_color;
	_tmp21_ = _tmp20_.alpha;
	if (_tmp21_ == 0.0) {
		gint x = 0;
		gint _tmp22_;
		cairo_surface_t* _tmp23_;
		gdouble _tmp24_;
		cairo_surface_t* _tmp25_;
		gint _tmp26_;
		_tmp22_ = width;
		_tmp23_ = self->priv->pixbuf_surface;
		_tmp24_ = scale_x;
		x = ((gint) (_tmp22_ - (cairo_image_surface_get_width (_tmp23_) * _tmp24_))) / 2;
		_tmp25_ = self->priv->pixbuf_surface;
		_tmp26_ = x;
		cairo_set_source_surface (ct, _tmp25_, (gdouble) _tmp26_, (gdouble) 0);
	} else {
		GdkRGBA _tmp27_;
		gdouble _tmp28_;
		GdkRGBA _tmp29_;
		gdouble _tmp30_;
		GdkRGBA _tmp31_;
		gdouble _tmp32_;
		GdkRGBA _tmp33_;
		gdouble _tmp34_;
		_tmp27_ = self->priv->bg_color;
		_tmp28_ = _tmp27_.red;
		_tmp29_ = self->priv->bg_color;
		_tmp30_ = _tmp29_.green;
		_tmp31_ = self->priv->bg_color;
		_tmp32_ = _tmp31_.blue;
		_tmp33_ = self->priv->bg_color;
		_tmp34_ = _tmp33_.alpha;
		cairo_set_source_rgba (ct, _tmp28_, _tmp30_, _tmp32_, _tmp34_);
	}
	_tmp35_ = self->priv->in_transition;
	if (_tmp35_) {
		gdouble _tmp36_;
		_tmp36_ = self->priv->alpha;
		cairo_paint_with_alpha (ct, _tmp36_);
	} else {
		cairo_paint (ct);
	}
	cairo_pop_group_to_source (ct);
	cairo_set_operator (ct, CAIRO_OPERATOR_OVER);
	cairo_paint (ct);
	result = GDK_EVENT_PROPAGATE;
	return result;
}


static gpointer
_cairo_surface_reference0 (gpointer self)
{
	return self ? cairo_surface_reference (self) : NULL;
}


void
aspect_image_set_pixbuf (AspectImage* self,
                         GdkPixbuf* value)
{
	g_return_if_fail (IS_ASPECT_IMAGE (self));
	if (value != NULL) {
		GdkPixbuf* _tmp0_;
		cairo_surface_t* _tmp1_;
		GdkWindow* _tmp4_;
		cairo_surface_t* _tmp5_;
		_tmp0_ = twitter_no_banner;
		if (value != _tmp0_) {
			aspect_image_start_animation (self);
		}
		_tmp1_ = self->priv->pixbuf_surface;
		if (_tmp1_ != NULL) {
			cairo_surface_t* _tmp2_;
			cairo_surface_t* _tmp3_;
			_tmp2_ = self->priv->pixbuf_surface;
			_tmp3_ = _cairo_surface_reference0 (_tmp2_);
			_cairo_surface_destroy0 (self->priv->old_surface);
			self->priv->old_surface = _tmp3_;
		}
		_tmp4_ = gtk_widget_get_window (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
		_tmp5_ = gdk_cairo_surface_create_from_pixbuf (value, 1, _tmp4_);
		_cairo_surface_destroy0 (self->priv->pixbuf_surface);
		self->priv->pixbuf_surface = (cairo_surface_t*) _tmp5_;
		self->priv->bg_color.alpha = 0.0;
	}
	gtk_widget_queue_draw (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	g_object_notify_by_pspec ((GObject *) self, aspect_image_properties[ASPECT_IMAGE_PIXBUF_PROPERTY]);
}


void
aspect_image_set_color_string (AspectImage* self,
                               const gchar* value)
{
	g_return_if_fail (IS_ASPECT_IMAGE (self));
	gdk_rgba_parse (&self->priv->bg_color, value);
	g_object_notify_by_pspec ((GObject *) self, aspect_image_properties[ASPECT_IMAGE_COLOR_STRING_PROPERTY]);
}


static GObject *
aspect_image_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AspectImage * self;
	parent_class = G_OBJECT_CLASS (aspect_image_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ASPECT_IMAGE, AspectImage);
	gtk_widget_set_has_window (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), FALSE);
	return obj;
}


static void
aspect_image_class_init (AspectImageClass * klass)
{
	aspect_image_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (AspectImagePrivate));
	((GtkWidgetClass *) klass)->get_preferred_height_for_width = (void (*) (GtkWidget *, gint, gint*, gint*)) aspect_image_real_get_preferred_height_for_width;
	((GtkWidgetClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkWidget *)) aspect_image_real_get_request_mode;
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget *, cairo_t*)) aspect_image_real_draw;
	G_OBJECT_CLASS (klass)->set_property = _vala_aspect_image_set_property;
	G_OBJECT_CLASS (klass)->constructor = aspect_image_constructor;
	G_OBJECT_CLASS (klass)->finalize = aspect_image_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), ASPECT_IMAGE_PIXBUF_PROPERTY, aspect_image_properties[ASPECT_IMAGE_PIXBUF_PROPERTY] = g_param_spec_object ("pixbuf", "pixbuf", "pixbuf", gdk_pixbuf_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ASPECT_IMAGE_COLOR_STRING_PROPERTY, aspect_image_properties[ASPECT_IMAGE_COLOR_STRING_PROPERTY] = g_param_spec_string ("color-string", "color-string", "color-string", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
}


static void
aspect_image_instance_init (AspectImage * self)
{
	self->priv = ASPECT_IMAGE_GET_PRIVATE (self);
	self->priv->pixbuf_surface = NULL;
	self->priv->alpha = 0.0;
	self->priv->in_transition = FALSE;
}


static void
aspect_image_finalize (GObject * obj)
{
	AspectImage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ASPECT_IMAGE, AspectImage);
	_cairo_surface_destroy0 (self->priv->old_surface);
	_cairo_surface_destroy0 (self->priv->pixbuf_surface);
	G_OBJECT_CLASS (aspect_image_parent_class)->finalize (obj);
}


GType
aspect_image_get_type (void)
{
	static volatile gsize aspect_image_type_id__volatile = 0;
	if (g_once_init_enter (&aspect_image_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AspectImageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) aspect_image_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AspectImage), 0, (GInstanceInitFunc) aspect_image_instance_init, NULL };
		GType aspect_image_type_id;
		aspect_image_type_id = g_type_register_static (gtk_widget_get_type (), "AspectImage", &g_define_type_info, 0);
		g_once_init_leave (&aspect_image_type_id__volatile, aspect_image_type_id);
	}
	return aspect_image_type_id__volatile;
}


static void
_vala_aspect_image_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	AspectImage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ASPECT_IMAGE, AspectImage);
	switch (property_id) {
		case ASPECT_IMAGE_PIXBUF_PROPERTY:
		aspect_image_set_pixbuf (self, g_value_get_object (value));
		break;
		case ASPECT_IMAGE_COLOR_STRING_PROPERTY:
		aspect_image_set_color_string (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



