/* ComposeImageManager.c generated by valac 0.40.0, the Vala compiler
 * generated from ComposeImageManager.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <cairo.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>


#define TYPE_COMPOSE_IMAGE_MANAGER (compose_image_manager_get_type ())
#define COMPOSE_IMAGE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPOSE_IMAGE_MANAGER, ComposeImageManager))
#define COMPOSE_IMAGE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPOSE_IMAGE_MANAGER, ComposeImageManagerClass))
#define IS_COMPOSE_IMAGE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPOSE_IMAGE_MANAGER))
#define IS_COMPOSE_IMAGE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPOSE_IMAGE_MANAGER))
#define COMPOSE_IMAGE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPOSE_IMAGE_MANAGER, ComposeImageManagerClass))

typedef struct _ComposeImageManager ComposeImageManager;
typedef struct _ComposeImageManagerClass ComposeImageManagerClass;
typedef struct _ComposeImageManagerPrivate ComposeImageManagerPrivate;

#define TYPE_ADD_IMAGE_BUTTON (add_image_button_get_type ())
#define ADD_IMAGE_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADD_IMAGE_BUTTON, AddImageButton))
#define ADD_IMAGE_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ADD_IMAGE_BUTTON, AddImageButtonClass))
#define IS_ADD_IMAGE_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADD_IMAGE_BUTTON))
#define IS_ADD_IMAGE_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ADD_IMAGE_BUTTON))
#define ADD_IMAGE_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ADD_IMAGE_BUTTON, AddImageButtonClass))

typedef struct _AddImageButton AddImageButton;
typedef struct _AddImageButtonClass AddImageButtonClass;
enum  {
	COMPOSE_IMAGE_MANAGER_0_PROPERTY,
	COMPOSE_IMAGE_MANAGER_N_IMAGES_PROPERTY,
	COMPOSE_IMAGE_MANAGER_HAS_GIF_PROPERTY,
	COMPOSE_IMAGE_MANAGER_FULL_PROPERTY,
	COMPOSE_IMAGE_MANAGER_NUM_PROPERTIES
};
static GParamSpec* compose_image_manager_properties[COMPOSE_IMAGE_MANAGER_NUM_PROPERTIES];
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
typedef struct _Block53Data Block53Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _AddImageButtonPrivate AddImageButtonPrivate;
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	COMPOSE_IMAGE_MANAGER_IMAGE_REMOVED_SIGNAL,
	COMPOSE_IMAGE_MANAGER_NUM_SIGNALS
};
static guint compose_image_manager_signals[COMPOSE_IMAGE_MANAGER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ComposeImageManager {
	GtkContainer parent_instance;
	ComposeImageManagerPrivate * priv;
};

struct _ComposeImageManagerClass {
	GtkContainerClass parent_class;
};

struct _ComposeImageManagerPrivate {
	GPtrArray* buttons;
	GPtrArray* close_buttons;
	GPtrArray* progress_bars;
};

struct _Block53Data {
	int _ref_count_;
	ComposeImageManager* self;
	gint index;
	AddImageButton* aib;
};

struct _AddImageButton {
	GtkWidget parent_instance;
	AddImageButtonPrivate * priv;
	gchar* image_path;
	cairo_surface_t* surface;
};

struct _AddImageButtonClass {
	GtkWidgetClass parent_class;
};


static gpointer compose_image_manager_parent_class = NULL;

GType compose_image_manager_get_type (void) G_GNUC_CONST;
GType add_image_button_get_type (void) G_GNUC_CONST;
#define COMPOSE_IMAGE_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_COMPOSE_IMAGE_MANAGER, ComposeImageManagerPrivate))
#define COMPOSE_IMAGE_MANAGER_BUTTON_DELTA 10
#define COMPOSE_IMAGE_MANAGER_BUTTON_SPACING 12
static void compose_image_manager_remove_clicked_cb (ComposeImageManager* self,
                                              GtkButton* source);
static Block53Data* block53_data_ref (Block53Data* _data53_);
static void block53_data_unref (void * _userdata_);
static void __lambda32_ (Block53Data* _data53_);
static void ___lambda32__add_image_button_deleted (AddImageButton* _sender,
                                            gpointer self);
void add_image_button_start_remove (AddImageButton* self);
static void compose_image_manager_real_forall_internal (GtkContainer* base,
                                                 gboolean include_internals,
                                                 GtkCallback cb,
                                                 void* cb_target);
static void compose_image_manager_real_add (GtkContainer* base,
                                     GtkWidget* widget);
static void _compose_image_manager_remove_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self);
static void compose_image_manager_real_remove (GtkContainer* base,
                                        GtkWidget* widget);
static GtkSizeRequestMode compose_image_manager_real_get_request_mode (GtkWidget* base);
static void compose_image_manager_real_size_allocate (GtkWidget* base,
                                               GtkAllocation* allocation);
void add_image_button_get_draw_size (AddImageButton* self,
                                     gint* width,
                                     gint* height,
                                     gdouble* scale);
static void compose_image_manager_real_get_preferred_height_for_width (GtkWidget* base,
                                                                gint width,
                                                                gint* minimum,
                                                                gint* natural);
static void compose_image_manager_real_get_preferred_height (GtkWidget* base,
                                                      gint* minimum,
                                                      gint* natural);
static void compose_image_manager_real_get_preferred_width (GtkWidget* base,
                                                     gint* minimum,
                                                     gint* natural);
static gboolean compose_image_manager_real_draw (GtkWidget* base,
                                          cairo_t* ct);
void compose_image_manager_load_image (ComposeImageManager* self,
                                       const gchar* path,
                                       GdkPixbuf* image);
cairo_surface_t* load_surface (const gchar* path);
AddImageButton* add_image_button_new (void);
AddImageButton* add_image_button_construct (GType object_type);
void compose_image_manager_set_image_progress (ComposeImageManager* self,
                                               const gchar* image_path,
                                               gdouble progress);
void compose_image_manager_end_progress (ComposeImageManager* self,
                                         const gchar* image_path,
                                         const gchar* error_message);
void compose_image_manager_insensitivize_buttons (ComposeImageManager* self);
ComposeImageManager* compose_image_manager_new (void);
ComposeImageManager* compose_image_manager_construct (GType object_type);
gint compose_image_manager_get_n_images (ComposeImageManager* self);
gboolean compose_image_manager_get_has_gif (ComposeImageManager* self);
gboolean compose_image_manager_get_full (ComposeImageManager* self);
#define TWITTER_max_media_per_upload 4
static GObject * compose_image_manager_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void _g_object_unref0_ (gpointer var);
static void compose_image_manager_finalize (GObject * obj);
static void _vala_compose_image_manager_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);


static Block53Data*
block53_data_ref (Block53Data* _data53_)
{
	g_atomic_int_inc (&_data53_->_ref_count_);
	return _data53_;
}


static void
block53_data_unref (void * _userdata_)
{
	Block53Data* _data53_;
	_data53_ = (Block53Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data53_->_ref_count_)) {
		ComposeImageManager* self;
		self = _data53_->self;
		_g_object_unref0 (_data53_->aib);
		_g_object_unref0 (self);
		g_slice_free (Block53Data, _data53_);
	}
}


static gint
g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->len;
	result = (gint) _tmp0_;
	return result;
}


static void
g_ptr_array_set_length (GPtrArray* self,
                        gint value)
{
	g_return_if_fail (self != NULL);
	g_ptr_array_set_size (self, value);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
__lambda32_ (Block53Data* _data53_)
{
	ComposeImageManager* self;
	GPtrArray* _tmp0_;
	gint _tmp1_;
	GPtrArray* _tmp2_;
	gint _tmp3_;
	GPtrArray* _tmp4_;
	gint _tmp5_;
	const gchar* _tmp6_;
	self = _data53_->self;
	_tmp0_ = self->priv->buttons;
	_tmp1_ = _data53_->index;
	g_ptr_array_remove_index (_tmp0_, (guint) _tmp1_);
	_tmp2_ = self->priv->close_buttons;
	_tmp3_ = _data53_->index;
	g_ptr_array_remove_index (_tmp2_, (guint) _tmp3_);
	_tmp4_ = self->priv->progress_bars;
	_tmp5_ = _data53_->index;
	g_ptr_array_remove_index (_tmp4_, (guint) _tmp5_);
	gtk_widget_queue_draw (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	_tmp6_ = _data53_->aib->image_path;
	g_signal_emit (self, compose_image_manager_signals[COMPOSE_IMAGE_MANAGER_IMAGE_REMOVED_SIGNAL], 0, _tmp6_);
}


static void
___lambda32__add_image_button_deleted (AddImageButton* _sender,
                                       gpointer self)
{
	__lambda32_ (self);
}


static void
compose_image_manager_remove_clicked_cb (ComposeImageManager* self,
                                         GtkButton* source)
{
	Block53Data* _data53_;
	gint _tmp10_;
	GPtrArray* _tmp11_;
	gint _tmp12_;
	gconstpointer _tmp13_;
	GPtrArray* _tmp14_;
	gint _tmp15_;
	gconstpointer _tmp16_;
	GPtrArray* _tmp17_;
	gint _tmp18_;
	gconstpointer _tmp19_;
	AddImageButton* _tmp20_;
	g_return_if_fail (IS_COMPOSE_IMAGE_MANAGER (self));
	g_return_if_fail (GTK_IS_BUTTON (source));
	_data53_ = g_slice_new0 (Block53Data);
	_data53_->_ref_count_ = 1;
	_data53_->self = g_object_ref (self);
	_data53_->index = -1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				GPtrArray* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				GPtrArray* _tmp6_;
				gint _tmp7_;
				gconstpointer _tmp8_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				_tmp3_ = self->priv->close_buttons;
				_tmp4_ = g_ptr_array_get_length (_tmp3_);
				_tmp5_ = _tmp4_;
				if (!(_tmp2_ < _tmp5_)) {
					break;
				}
				_tmp6_ = self->priv->close_buttons;
				_tmp7_ = i;
				_tmp8_ = g_ptr_array_index (_tmp6_, (guint) _tmp7_);
				if (((GtkButton*) _tmp8_) == source) {
					gint _tmp9_;
					_tmp9_ = i;
					_data53_->index = _tmp9_;
					break;
				}
			}
		}
	}
	_tmp10_ = _data53_->index;
	_vala_assert (_tmp10_ >= 0, "index >= 0");
	_tmp11_ = self->priv->close_buttons;
	_tmp12_ = _data53_->index;
	_tmp13_ = g_ptr_array_index (_tmp11_, (guint) _tmp12_);
	gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST ((GtkButton*) _tmp13_, gtk_widget_get_type (), GtkWidget));
	_tmp14_ = self->priv->progress_bars;
	_tmp15_ = _data53_->index;
	_tmp16_ = g_ptr_array_index (_tmp14_, (guint) _tmp15_);
	gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST ((GtkProgressBar*) _tmp16_, gtk_widget_get_type (), GtkWidget));
	_tmp17_ = self->priv->buttons;
	_tmp18_ = _data53_->index;
	_tmp19_ = g_ptr_array_index (_tmp17_, (guint) _tmp18_);
	_tmp20_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST ((AddImageButton*) _tmp19_, TYPE_ADD_IMAGE_BUTTON, AddImageButton));
	_data53_->aib = _tmp20_;
	g_signal_connect_data (_data53_->aib, "deleted", (GCallback) ___lambda32__add_image_button_deleted, block53_data_ref (_data53_), (GClosureNotify) block53_data_unref, 0);
	add_image_button_start_remove (_data53_->aib);
	block53_data_unref (_data53_);
	_data53_ = NULL;
}


static void
compose_image_manager_real_forall_internal (GtkContainer* base,
                                            gboolean include_internals,
                                            GtkCallback cb,
                                            void* cb_target)
{
	ComposeImageManager * self;
	GPtrArray* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GPtrArray* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GPtrArray* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GPtrArray* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_COMPOSE_IMAGE_MANAGER, ComposeImageManager);
	_tmp0_ = self->priv->buttons;
	_tmp1_ = g_ptr_array_get_length (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->close_buttons;
	_tmp4_ = g_ptr_array_get_length (_tmp3_);
	_tmp5_ = _tmp4_;
	_vala_assert (_tmp2_ == _tmp5_, "buttons.length == close_buttons.length");
	_tmp6_ = self->priv->buttons;
	_tmp7_ = g_ptr_array_get_length (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = self->priv->progress_bars;
	_tmp10_ = g_ptr_array_get_length (_tmp9_);
	_tmp11_ = _tmp10_;
	_vala_assert (_tmp8_ == _tmp11_, "buttons.length == progress_bars.length");
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp12_ = FALSE;
			_tmp12_ = TRUE;
			while (TRUE) {
				gint _tmp13_;
				GPtrArray* _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				gint size_before = 0;
				GPtrArray* _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
				GPtrArray* _tmp20_;
				gint _tmp21_;
				gconstpointer _tmp22_;
				gint _tmp23_;
				GPtrArray* _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
				if (!_tmp12_) {
				}
				_tmp12_ = FALSE;
				_tmp13_ = i;
				_tmp14_ = self->priv->close_buttons;
				_tmp15_ = g_ptr_array_get_length (_tmp14_);
				_tmp16_ = _tmp15_;
				if (!(_tmp13_ < _tmp16_)) {
					break;
				}
				_tmp17_ = self->priv->close_buttons;
				_tmp18_ = g_ptr_array_get_length (_tmp17_);
				_tmp19_ = _tmp18_;
				size_before = _tmp19_;
				_tmp20_ = self->priv->close_buttons;
				_tmp21_ = i;
				_tmp22_ = g_ptr_array_index (_tmp20_, (guint) _tmp21_);
				cb (G_TYPE_CHECK_INSTANCE_CAST ((GtkButton*) _tmp22_, gtk_widget_get_type (), GtkWidget), cb_target);
				_tmp23_ = i;
				_tmp24_ = self->priv->close_buttons;
				_tmp25_ = g_ptr_array_get_length (_tmp24_);
				_tmp26_ = _tmp25_;
				_tmp27_ = size_before;
				i = _tmp23_ + ((_tmp26_ - _tmp27_) + 1);
			}
		}
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp28_ = FALSE;
			_tmp28_ = TRUE;
			while (TRUE) {
				gint _tmp29_;
				GPtrArray* _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
				gint size_before = 0;
				GPtrArray* _tmp33_;
				gint _tmp34_;
				gint _tmp35_;
				GPtrArray* _tmp36_;
				gint _tmp37_;
				gconstpointer _tmp38_;
				gint _tmp39_;
				GPtrArray* _tmp40_;
				gint _tmp41_;
				gint _tmp42_;
				gint _tmp43_;
				if (!_tmp28_) {
				}
				_tmp28_ = FALSE;
				_tmp29_ = i;
				_tmp30_ = self->priv->progress_bars;
				_tmp31_ = g_ptr_array_get_length (_tmp30_);
				_tmp32_ = _tmp31_;
				if (!(_tmp29_ < _tmp32_)) {
					break;
				}
				_tmp33_ = self->priv->progress_bars;
				_tmp34_ = g_ptr_array_get_length (_tmp33_);
				_tmp35_ = _tmp34_;
				size_before = _tmp35_;
				_tmp36_ = self->priv->progress_bars;
				_tmp37_ = i;
				_tmp38_ = g_ptr_array_index (_tmp36_, (guint) _tmp37_);
				cb (G_TYPE_CHECK_INSTANCE_CAST ((GtkProgressBar*) _tmp38_, gtk_widget_get_type (), GtkWidget), cb_target);
				_tmp39_ = i;
				_tmp40_ = self->priv->progress_bars;
				_tmp41_ = g_ptr_array_get_length (_tmp40_);
				_tmp42_ = _tmp41_;
				_tmp43_ = size_before;
				i = _tmp39_ + ((_tmp42_ - _tmp43_) + 1);
			}
		}
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp44_ = FALSE;
			_tmp44_ = TRUE;
			while (TRUE) {
				gint _tmp45_;
				GPtrArray* _tmp46_;
				gint _tmp47_;
				gint _tmp48_;
				gint size_before = 0;
				GPtrArray* _tmp49_;
				gint _tmp50_;
				gint _tmp51_;
				GPtrArray* _tmp52_;
				gint _tmp53_;
				gconstpointer _tmp54_;
				gint _tmp55_;
				GPtrArray* _tmp56_;
				gint _tmp57_;
				gint _tmp58_;
				gint _tmp59_;
				if (!_tmp44_) {
				}
				_tmp44_ = FALSE;
				_tmp45_ = i;
				_tmp46_ = self->priv->buttons;
				_tmp47_ = g_ptr_array_get_length (_tmp46_);
				_tmp48_ = _tmp47_;
				if (!(_tmp45_ < _tmp48_)) {
					break;
				}
				_tmp49_ = self->priv->buttons;
				_tmp50_ = g_ptr_array_get_length (_tmp49_);
				_tmp51_ = _tmp50_;
				size_before = _tmp51_;
				_tmp52_ = self->priv->buttons;
				_tmp53_ = i;
				_tmp54_ = g_ptr_array_index (_tmp52_, (guint) _tmp53_);
				cb (G_TYPE_CHECK_INSTANCE_CAST ((AddImageButton*) _tmp54_, gtk_widget_get_type (), GtkWidget), cb_target);
				_tmp55_ = i;
				_tmp56_ = self->priv->buttons;
				_tmp57_ = g_ptr_array_get_length (_tmp56_);
				_tmp58_ = _tmp57_;
				_tmp59_ = size_before;
				i = _tmp55_ + ((_tmp58_ - _tmp59_) + 1);
			}
		}
	}
}


static void
_compose_image_manager_remove_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self)
{
	compose_image_manager_remove_clicked_cb ((ComposeImageManager*) self, _sender);
}


static void
compose_image_manager_real_add (GtkContainer* base,
                                GtkWidget* widget)
{
	ComposeImageManager * self;
	GPtrArray* _tmp0_;
	AddImageButton* _tmp1_;
	GtkButton* btn = NULL;
	GtkButton* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkStyleContext* _tmp4_;
	GPtrArray* _tmp5_;
	GtkButton* _tmp6_;
	GtkProgressBar* bar = NULL;
	GtkProgressBar* _tmp7_;
	GPtrArray* _tmp8_;
	GtkProgressBar* _tmp9_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_COMPOSE_IMAGE_MANAGER, ComposeImageManager);
	g_return_if_fail (GTK_IS_WIDGET (widget));
	gtk_widget_set_parent (widget, (GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer));
	_tmp0_ = self->priv->buttons;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (widget, TYPE_ADD_IMAGE_BUTTON, AddImageButton));
	g_ptr_array_add (_tmp0_, _tmp1_);
	_tmp2_ = (GtkButton*) gtk_button_new_from_icon_name ("window-close-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp2_);
	btn = _tmp2_;
	gtk_widget_set_parent (G_TYPE_CHECK_INSTANCE_CAST (btn, gtk_widget_get_type (), GtkWidget), (GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer));
	_tmp3_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (btn, gtk_widget_get_type (), GtkWidget));
	gtk_style_context_add_class (_tmp3_, "image-button");
	_tmp4_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (btn, gtk_widget_get_type (), GtkWidget));
	gtk_style_context_add_class (_tmp4_, "close-button");
	g_signal_connect_object (btn, "clicked", (GCallback) _compose_image_manager_remove_clicked_cb_gtk_button_clicked, self, 0);
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (btn, gtk_widget_get_type (), GtkWidget));
	_tmp5_ = self->priv->close_buttons;
	_tmp6_ = _g_object_ref0 (btn);
	g_ptr_array_add (_tmp5_, _tmp6_);
	_tmp7_ = (GtkProgressBar*) gtk_progress_bar_new ();
	g_object_ref_sink (_tmp7_);
	bar = _tmp7_;
	gtk_widget_set_parent (G_TYPE_CHECK_INSTANCE_CAST (bar, gtk_widget_get_type (), GtkWidget), (GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer));
	gtk_widget_show_all (G_TYPE_CHECK_INSTANCE_CAST (bar, gtk_widget_get_type (), GtkWidget));
	_tmp8_ = self->priv->progress_bars;
	_tmp9_ = _g_object_ref0 (bar);
	g_ptr_array_add (_tmp8_, _tmp9_);
	_g_object_unref0 (bar);
	_g_object_unref0 (btn);
}


static void
compose_image_manager_real_remove (GtkContainer* base,
                                   GtkWidget* widget)
{
	ComposeImageManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_COMPOSE_IMAGE_MANAGER, ComposeImageManager);
	g_return_if_fail (GTK_IS_WIDGET (widget));
	gtk_widget_unparent (widget);
	if (G_TYPE_CHECK_INSTANCE_TYPE (widget, TYPE_ADD_IMAGE_BUTTON)) {
		GPtrArray* _tmp0_;
		_tmp0_ = self->priv->buttons;
		g_ptr_array_remove (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (widget, TYPE_ADD_IMAGE_BUTTON, AddImageButton));
	} else {
		if (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_button_get_type ())) {
			GPtrArray* _tmp1_;
			_tmp1_ = self->priv->close_buttons;
			g_ptr_array_remove (_tmp1_, G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_button_get_type (), GtkButton));
		} else {
			GPtrArray* _tmp2_;
			_tmp2_ = self->priv->progress_bars;
			g_ptr_array_remove (_tmp2_, G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_progress_bar_get_type (), GtkProgressBar));
		}
	}
}


static GtkSizeRequestMode
compose_image_manager_real_get_request_mode (GtkWidget* base)
{
	ComposeImageManager * self;
	GtkSizeRequestMode result = 0;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_COMPOSE_IMAGE_MANAGER, ComposeImageManager);
	result = GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH;
	return result;
}


static void
compose_image_manager_real_size_allocate (GtkWidget* base,
                                          GtkAllocation* allocation)
{
	ComposeImageManager * self;
	GtkAllocation _tmp0_;
	GtkAllocation child_allocation = {0};
	GtkAllocation _tmp1_ = {0};
	GPtrArray* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint default_button_width = 0;
	GtkAllocation _tmp5_;
	gint _tmp6_;
	GPtrArray* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	GPtrArray* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	GtkAllocation _tmp13_;
	gint _tmp14_;
	GtkAllocation _tmp15_;
	gint _tmp16_;
	GtkAllocation _tmp17_;
	gint _tmp18_;
	GtkAllocation close_allocation = {0};
	GtkAllocation _tmp19_ = {0};
	GtkAllocation _tmp20_;
	gint _tmp21_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_COMPOSE_IMAGE_MANAGER, ComposeImageManager);
	g_return_if_fail (allocation != NULL);
	_tmp0_ = *allocation;
	GTK_WIDGET_CLASS (compose_image_manager_parent_class)->size_allocate (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), gtk_widget_get_type (), GtkWidget), &_tmp0_);
	child_allocation = _tmp1_;
	_tmp2_ = self->priv->buttons;
	_tmp3_ = g_ptr_array_get_length (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_ == 0) {
		return;
	}
	_tmp5_ = *allocation;
	_tmp6_ = _tmp5_.width;
	_tmp7_ = self->priv->buttons;
	_tmp8_ = g_ptr_array_get_length (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = self->priv->buttons;
	_tmp11_ = g_ptr_array_get_length (_tmp10_);
	_tmp12_ = _tmp11_;
	default_button_width = (_tmp6_ - (_tmp9_ * COMPOSE_IMAGE_MANAGER_BUTTON_SPACING)) / _tmp12_;
	_tmp13_ = *allocation;
	_tmp14_ = _tmp13_.x;
	child_allocation.x = _tmp14_;
	_tmp15_ = *allocation;
	_tmp16_ = _tmp15_.y;
	child_allocation.y = _tmp16_ + COMPOSE_IMAGE_MANAGER_BUTTON_DELTA;
	_tmp17_ = *allocation;
	_tmp18_ = _tmp17_.height;
	child_allocation.height = MAX (_tmp18_ - COMPOSE_IMAGE_MANAGER_BUTTON_DELTA, 0);
	close_allocation = _tmp19_;
	_tmp20_ = *allocation;
	_tmp21_ = _tmp20_.y;
	close_allocation.y = _tmp21_;
	{
		gint i = 0;
		gint p = 0;
		GPtrArray* _tmp22_;
		gint _tmp23_;
		gint _tmp24_;
		i = 0;
		_tmp22_ = self->priv->buttons;
		_tmp23_ = g_ptr_array_get_length (_tmp22_);
		_tmp24_ = _tmp23_;
		p = _tmp24_;
		{
			gboolean _tmp25_ = FALSE;
			_tmp25_ = TRUE;
			while (TRUE) {
				gint _tmp27_;
				gint _tmp28_;
				gint min = 0;
				gint nat = 0;
				AddImageButton* aib = NULL;
				GPtrArray* _tmp29_;
				gint _tmp30_;
				gconstpointer _tmp31_;
				AddImageButton* _tmp32_;
				AddImageButton* _tmp33_;
				GtkAllocation _tmp34_;
				gint _tmp35_;
				gint _tmp36_ = 0;
				gint _tmp37_ = 0;
				gint _tmp38_;
				gint _tmp39_;
				AddImageButton* _tmp40_;
				GtkAllocation _tmp41_;
				gint n = 0;
				GtkWidget* btn = NULL;
				GPtrArray* _tmp42_;
				gint _tmp43_;
				gconstpointer _tmp44_;
				GtkWidget* _tmp45_;
				GtkWidget* _tmp46_;
				gint _tmp47_ = 0;
				gint _tmp48_ = 0;
				GtkWidget* _tmp49_;
				gint _tmp50_ = 0;
				gint _tmp51_ = 0;
				GtkAllocation _tmp52_;
				gint _tmp53_;
				GtkAllocation _tmp54_;
				gint _tmp55_;
				GtkAllocation _tmp56_;
				gint _tmp57_;
				GtkWidget* _tmp58_;
				GtkAllocation _tmp59_;
				gint button_width = 0;
				gint button_height = 0;
				gdouble scale = 0.0;
				AddImageButton* _tmp60_;
				gint _tmp61_ = 0;
				gint _tmp62_ = 0;
				gdouble _tmp63_ = 0.0;
				GtkWidget* bar = NULL;
				GPtrArray* _tmp64_;
				gint _tmp65_;
				gconstpointer _tmp66_;
				GtkWidget* _tmp67_;
				GtkAllocation bar_allocation = {0};
				GtkAllocation _tmp68_ = {0};
				GtkAllocation _tmp69_;
				gint _tmp70_;
				GtkWidget* _tmp71_;
				gint _tmp72_ = 0;
				gint _tmp73_ = 0;
				gint _tmp74_;
				GtkAllocation _tmp75_;
				gint _tmp76_;
				GtkWidget* _tmp77_;
				gint _tmp78_ = 0;
				gint _tmp79_ = 0;
				GtkAllocation _tmp80_;
				gint _tmp81_;
				gint _tmp82_;
				GtkAllocation _tmp83_;
				gint _tmp84_;
				GtkWidget* _tmp85_;
				GtkAllocation _tmp86_;
				gint _tmp87_;
				GtkAllocation _tmp88_;
				gint _tmp89_;
				if (!_tmp25_) {
					gint _tmp26_;
					_tmp26_ = i;
					i = _tmp26_ + 1;
				}
				_tmp25_ = FALSE;
				_tmp27_ = i;
				_tmp28_ = p;
				if (!(_tmp27_ < _tmp28_)) {
					break;
				}
				_tmp29_ = self->priv->buttons;
				_tmp30_ = i;
				_tmp31_ = g_ptr_array_index (_tmp29_, (guint) _tmp30_);
				_tmp32_ = _g_object_ref0 ((AddImageButton*) _tmp31_);
				aib = _tmp32_;
				_tmp33_ = aib;
				_tmp34_ = child_allocation;
				_tmp35_ = _tmp34_.height;
				gtk_widget_get_preferred_width_for_height (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, gtk_widget_get_type (), GtkWidget), _tmp35_, &_tmp36_, &_tmp37_);
				min = _tmp36_;
				nat = _tmp37_;
				_tmp38_ = default_button_width;
				_tmp39_ = nat;
				child_allocation.width = MIN (_tmp38_, _tmp39_);
				_tmp40_ = aib;
				_tmp41_ = child_allocation;
				gtk_widget_size_allocate (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, gtk_widget_get_type (), GtkWidget), &_tmp41_);
				_tmp42_ = self->priv->close_buttons;
				_tmp43_ = i;
				_tmp44_ = g_ptr_array_index (_tmp42_, (guint) _tmp43_);
				_tmp45_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST ((GtkButton*) _tmp44_, gtk_widget_get_type (), GtkWidget));
				btn = _tmp45_;
				_tmp46_ = btn;
				gtk_widget_get_preferred_width (_tmp46_, &_tmp47_, &_tmp48_);
				close_allocation.width = _tmp47_;
				n = _tmp48_;
				_tmp49_ = btn;
				gtk_widget_get_preferred_height (_tmp49_, &_tmp50_, &_tmp51_);
				close_allocation.height = _tmp50_;
				n = _tmp51_;
				_tmp52_ = child_allocation;
				_tmp53_ = _tmp52_.x;
				_tmp54_ = child_allocation;
				_tmp55_ = _tmp54_.width;
				_tmp56_ = close_allocation;
				_tmp57_ = _tmp56_.width;
				close_allocation.x = ((_tmp53_ + _tmp55_) - _tmp57_) + COMPOSE_IMAGE_MANAGER_BUTTON_DELTA;
				_tmp58_ = btn;
				_tmp59_ = close_allocation;
				gtk_widget_size_allocate (_tmp58_, &_tmp59_);
				_tmp60_ = aib;
				add_image_button_get_draw_size (_tmp60_, &_tmp61_, &_tmp62_, &_tmp63_);
				button_width = _tmp61_;
				button_height = _tmp62_;
				scale = _tmp63_;
				_tmp64_ = self->priv->progress_bars;
				_tmp65_ = i;
				_tmp66_ = g_ptr_array_index (_tmp64_, (guint) _tmp65_);
				_tmp67_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST ((GtkProgressBar*) _tmp66_, gtk_widget_get_type (), GtkWidget));
				bar = _tmp67_;
				_tmp68_.x = 0;
				bar_allocation = _tmp68_;
				_tmp69_ = child_allocation;
				_tmp70_ = _tmp69_.x;
				bar_allocation.x = _tmp70_ + 6;
				_tmp71_ = bar;
				gtk_widget_get_preferred_width (_tmp71_, &_tmp72_, &_tmp73_);
				bar_allocation.width = _tmp72_;
				n = _tmp73_;
				_tmp74_ = button_width;
				_tmp75_ = bar_allocation;
				_tmp76_ = _tmp75_.width;
				bar_allocation.width = MAX (_tmp74_ - 12, _tmp76_);
				_tmp77_ = bar;
				gtk_widget_get_preferred_height (_tmp77_, &_tmp78_, &_tmp79_);
				bar_allocation.height = _tmp78_;
				n = _tmp79_;
				_tmp80_ = child_allocation;
				_tmp81_ = _tmp80_.y;
				_tmp82_ = button_height;
				_tmp83_ = bar_allocation;
				_tmp84_ = _tmp83_.height;
				bar_allocation.y = ((_tmp81_ + _tmp82_) - _tmp84_) - 6;
				_tmp85_ = bar;
				_tmp86_ = bar_allocation;
				gtk_widget_size_allocate (_tmp85_, &_tmp86_);
				_tmp87_ = child_allocation.x;
				_tmp88_ = child_allocation;
				_tmp89_ = _tmp88_.width;
				child_allocation.x = _tmp87_ + (_tmp89_ + COMPOSE_IMAGE_MANAGER_BUTTON_SPACING);
				_g_object_unref0 (bar);
				_g_object_unref0 (btn);
				_g_object_unref0 (aib);
			}
		}
	}
}


static void
compose_image_manager_real_get_preferred_height_for_width (GtkWidget* base,
                                                           gint width,
                                                           gint* minimum,
                                                           gint* natural)
{
	ComposeImageManager * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint min = 0;
	gint nat = 0;
	gint _tmp17_;
	gint _tmp18_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_COMPOSE_IMAGE_MANAGER, ComposeImageManager);
	min = 0;
	nat = 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				GPtrArray* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				AddImageButton* btn = NULL;
				GPtrArray* _tmp6_;
				gint _tmp7_;
				gconstpointer _tmp8_;
				AddImageButton* _tmp9_;
				gint m = 0;
				gint n = 0;
				AddImageButton* _tmp10_;
				gint _tmp11_ = 0;
				gint _tmp12_ = 0;
				gint _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				_tmp3_ = self->priv->buttons;
				_tmp4_ = g_ptr_array_get_length (_tmp3_);
				_tmp5_ = _tmp4_;
				if (!(_tmp2_ < _tmp5_)) {
					break;
				}
				_tmp6_ = self->priv->buttons;
				_tmp7_ = i;
				_tmp8_ = g_ptr_array_index (_tmp6_, (guint) _tmp7_);
				_tmp9_ = _g_object_ref0 ((AddImageButton*) _tmp8_);
				btn = _tmp9_;
				_tmp10_ = btn;
				gtk_widget_get_preferred_height_for_width (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_widget_get_type (), GtkWidget), width, &_tmp11_, &_tmp12_);
				m = _tmp11_;
				n = _tmp12_;
				_tmp13_ = m;
				_tmp14_ = min;
				min = MAX (_tmp13_, _tmp14_);
				_tmp15_ = n;
				_tmp16_ = nat;
				nat = MAX (_tmp15_, _tmp16_);
				_g_object_unref0 (btn);
			}
		}
	}
	_tmp17_ = min;
	_vala_minimum = _tmp17_ + COMPOSE_IMAGE_MANAGER_BUTTON_DELTA;
	_tmp18_ = nat;
	_vala_natural = _tmp18_ + COMPOSE_IMAGE_MANAGER_BUTTON_DELTA;
	if (minimum) {
		*minimum = _vala_minimum;
	}
	if (natural) {
		*natural = _vala_natural;
	}
}


static void
compose_image_manager_real_get_preferred_height (GtkWidget* base,
                                                 gint* minimum,
                                                 gint* natural)
{
	ComposeImageManager * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint min = 0;
	gint nat = 0;
	gint _tmp17_;
	gint _tmp18_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_COMPOSE_IMAGE_MANAGER, ComposeImageManager);
	min = 0;
	nat = 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				GPtrArray* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				AddImageButton* btn = NULL;
				GPtrArray* _tmp6_;
				gint _tmp7_;
				gconstpointer _tmp8_;
				AddImageButton* _tmp9_;
				gint m = 0;
				gint n = 0;
				AddImageButton* _tmp10_;
				gint _tmp11_ = 0;
				gint _tmp12_ = 0;
				gint _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				_tmp3_ = self->priv->buttons;
				_tmp4_ = g_ptr_array_get_length (_tmp3_);
				_tmp5_ = _tmp4_;
				if (!(_tmp2_ < _tmp5_)) {
					break;
				}
				_tmp6_ = self->priv->buttons;
				_tmp7_ = i;
				_tmp8_ = g_ptr_array_index (_tmp6_, (guint) _tmp7_);
				_tmp9_ = _g_object_ref0 ((AddImageButton*) _tmp8_);
				btn = _tmp9_;
				_tmp10_ = btn;
				gtk_widget_get_preferred_height (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_widget_get_type (), GtkWidget), &_tmp11_, &_tmp12_);
				m = _tmp11_;
				n = _tmp12_;
				_tmp13_ = m;
				_tmp14_ = min;
				min = MAX (_tmp13_, _tmp14_);
				_tmp15_ = n;
				_tmp16_ = nat;
				nat = MAX (_tmp15_, _tmp16_);
				_g_object_unref0 (btn);
			}
		}
	}
	_tmp17_ = min;
	_vala_minimum = _tmp17_ + COMPOSE_IMAGE_MANAGER_BUTTON_DELTA;
	_tmp18_ = nat;
	_vala_natural = _tmp18_ + COMPOSE_IMAGE_MANAGER_BUTTON_DELTA;
	if (minimum) {
		*minimum = _vala_minimum;
	}
	if (natural) {
		*natural = _vala_natural;
	}
}


static void
compose_image_manager_real_get_preferred_width (GtkWidget* base,
                                                gint* minimum,
                                                gint* natural)
{
	ComposeImageManager * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint min = 0;
	gint nat = 0;
	gint _tmp17_;
	GPtrArray* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	GPtrArray* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_COMPOSE_IMAGE_MANAGER, ComposeImageManager);
	min = 0;
	nat = 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				GPtrArray* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				AddImageButton* btn = NULL;
				GPtrArray* _tmp6_;
				gint _tmp7_;
				gconstpointer _tmp8_;
				AddImageButton* _tmp9_;
				gint m = 0;
				gint n = 0;
				AddImageButton* _tmp10_;
				gint _tmp11_ = 0;
				gint _tmp12_ = 0;
				gint _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				_tmp3_ = self->priv->buttons;
				_tmp4_ = g_ptr_array_get_length (_tmp3_);
				_tmp5_ = _tmp4_;
				if (!(_tmp2_ < _tmp5_)) {
					break;
				}
				_tmp6_ = self->priv->buttons;
				_tmp7_ = i;
				_tmp8_ = g_ptr_array_index (_tmp6_, (guint) _tmp7_);
				_tmp9_ = _g_object_ref0 ((AddImageButton*) _tmp8_);
				btn = _tmp9_;
				_tmp10_ = btn;
				gtk_widget_get_preferred_width (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_widget_get_type (), GtkWidget), &_tmp11_, &_tmp12_);
				m = _tmp11_;
				n = _tmp12_;
				_tmp13_ = min;
				_tmp14_ = m;
				min = _tmp13_ + _tmp14_;
				_tmp15_ = nat;
				_tmp16_ = n;
				nat = _tmp15_ + _tmp16_;
				_g_object_unref0 (btn);
			}
		}
	}
	_tmp17_ = min;
	_tmp18_ = self->priv->buttons;
	_tmp19_ = g_ptr_array_get_length (_tmp18_);
	_tmp20_ = _tmp19_;
	_vala_minimum = _tmp17_ + (_tmp20_ * COMPOSE_IMAGE_MANAGER_BUTTON_SPACING);
	_tmp21_ = nat;
	_tmp22_ = self->priv->buttons;
	_tmp23_ = g_ptr_array_get_length (_tmp22_);
	_tmp24_ = _tmp23_;
	_vala_natural = _tmp21_ + (_tmp24_ * COMPOSE_IMAGE_MANAGER_BUTTON_SPACING);
	if (minimum) {
		*minimum = _vala_minimum;
	}
	if (natural) {
		*natural = _vala_natural;
	}
}


static gboolean
compose_image_manager_real_draw (GtkWidget* base,
                                 cairo_t* ct)
{
	ComposeImageManager * self;
	gboolean result = FALSE;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_COMPOSE_IMAGE_MANAGER, ComposeImageManager);
	g_return_val_if_fail (ct != NULL, FALSE);
	{
		gint i = 0;
		gint p = 0;
		GPtrArray* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		i = 0;
		_tmp0_ = self->priv->buttons;
		_tmp1_ = g_ptr_array_get_length (_tmp0_);
		_tmp2_ = _tmp1_;
		p = _tmp2_;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gint _tmp5_;
				gint _tmp6_;
				GtkWidget* btn = NULL;
				GPtrArray* _tmp7_;
				gint _tmp8_;
				gconstpointer _tmp9_;
				GtkWidget* _tmp10_;
				GtkWidget* _tmp11_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = i;
				_tmp6_ = p;
				if (!(_tmp5_ < _tmp6_)) {
					break;
				}
				_tmp7_ = self->priv->buttons;
				_tmp8_ = i;
				_tmp9_ = g_ptr_array_index (_tmp7_, (guint) _tmp8_);
				_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST ((AddImageButton*) _tmp9_, gtk_widget_get_type (), GtkWidget));
				btn = _tmp10_;
				_tmp11_ = btn;
				gtk_container_propagate_draw (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), _tmp11_, ct);
				_g_object_unref0 (btn);
			}
		}
	}
	{
		gint i = 0;
		gint p = 0;
		GPtrArray* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		i = 0;
		_tmp12_ = self->priv->close_buttons;
		_tmp13_ = g_ptr_array_get_length (_tmp12_);
		_tmp14_ = _tmp13_;
		p = _tmp14_;
		{
			gboolean _tmp15_ = FALSE;
			_tmp15_ = TRUE;
			while (TRUE) {
				gint _tmp17_;
				gint _tmp18_;
				GtkButton* btn = NULL;
				GPtrArray* _tmp19_;
				gint _tmp20_;
				gconstpointer _tmp21_;
				GtkButton* _tmp22_;
				GtkButton* _tmp23_;
				if (!_tmp15_) {
					gint _tmp16_;
					_tmp16_ = i;
					i = _tmp16_ + 1;
				}
				_tmp15_ = FALSE;
				_tmp17_ = i;
				_tmp18_ = p;
				if (!(_tmp17_ < _tmp18_)) {
					break;
				}
				_tmp19_ = self->priv->close_buttons;
				_tmp20_ = i;
				_tmp21_ = g_ptr_array_index (_tmp19_, (guint) _tmp20_);
				_tmp22_ = _g_object_ref0 ((GtkButton*) _tmp21_);
				btn = _tmp22_;
				_tmp23_ = btn;
				gtk_container_propagate_draw (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, gtk_widget_get_type (), GtkWidget), ct);
				_g_object_unref0 (btn);
			}
		}
	}
	{
		gint i = 0;
		gint p = 0;
		GPtrArray* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		i = 0;
		_tmp24_ = self->priv->progress_bars;
		_tmp25_ = g_ptr_array_get_length (_tmp24_);
		_tmp26_ = _tmp25_;
		p = _tmp26_;
		{
			gboolean _tmp27_ = FALSE;
			_tmp27_ = TRUE;
			while (TRUE) {
				gint _tmp29_;
				gint _tmp30_;
				GtkProgressBar* bar = NULL;
				GPtrArray* _tmp31_;
				gint _tmp32_;
				gconstpointer _tmp33_;
				GtkProgressBar* _tmp34_;
				GtkProgressBar* _tmp35_;
				if (!_tmp27_) {
					gint _tmp28_;
					_tmp28_ = i;
					i = _tmp28_ + 1;
				}
				_tmp27_ = FALSE;
				_tmp29_ = i;
				_tmp30_ = p;
				if (!(_tmp29_ < _tmp30_)) {
					break;
				}
				_tmp31_ = self->priv->progress_bars;
				_tmp32_ = i;
				_tmp33_ = g_ptr_array_index (_tmp31_, (guint) _tmp32_);
				_tmp34_ = _g_object_ref0 ((GtkProgressBar*) _tmp33_);
				bar = _tmp34_;
				_tmp35_ = bar;
				gtk_container_propagate_draw (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, gtk_widget_get_type (), GtkWidget), ct);
				_g_object_unref0 (bar);
			}
		}
	}
	result = GDK_EVENT_PROPAGATE;
	return result;
}


static gpointer
_cairo_surface_reference0 (gpointer self)
{
	return self ? cairo_surface_reference (self) : NULL;
}


void
compose_image_manager_load_image (ComposeImageManager* self,
                                  const gchar* path,
                                  GdkPixbuf* image)
{
	cairo_surface_t* surface = NULL;
	AddImageButton* button = NULL;
	AddImageButton* _tmp3_;
	cairo_surface_t* _tmp4_;
	cairo_surface_t* _tmp5_;
	gchar* _tmp6_;
	g_return_if_fail (IS_COMPOSE_IMAGE_MANAGER (self));
	g_return_if_fail (path != NULL);
	g_return_if_fail ((image == NULL) || GDK_IS_PIXBUF (image));
	if (image == NULL) {
		cairo_surface_t* _tmp0_;
		_tmp0_ = load_surface (path);
		_cairo_surface_destroy0 (surface);
		surface = (cairo_surface_t*) _tmp0_;
	} else {
		GdkWindow* _tmp1_;
		cairo_surface_t* _tmp2_;
		_tmp1_ = gtk_widget_get_window (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
		_tmp2_ = gdk_cairo_surface_create_from_pixbuf (image, gtk_widget_get_scale_factor (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget)), _tmp1_);
		_cairo_surface_destroy0 (surface);
		surface = (cairo_surface_t*) _tmp2_;
	}
	_tmp3_ = add_image_button_new ();
	g_object_ref_sink (_tmp3_);
	button = _tmp3_;
	_tmp4_ = surface;
	_tmp5_ = _cairo_surface_reference0 (_tmp4_);
	_cairo_surface_destroy0 (button->surface);
	button->surface = _tmp5_;
	_tmp6_ = g_strdup (path);
	_g_free0 (button->image_path);
	button->image_path = _tmp6_;
	gtk_widget_set_hexpand (G_TYPE_CHECK_INSTANCE_CAST (button, gtk_widget_get_type (), GtkWidget), FALSE);
	gtk_widget_set_halign (G_TYPE_CHECK_INSTANCE_CAST (button, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_START);
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (button, gtk_widget_get_type (), GtkWidget));
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (button, gtk_widget_get_type (), GtkWidget));
	_g_object_unref0 (button);
	_cairo_surface_destroy0 (surface);
}


void
compose_image_manager_set_image_progress (ComposeImageManager* self,
                                          const gchar* image_path,
                                          gdouble progress)
{
	g_return_if_fail (IS_COMPOSE_IMAGE_MANAGER (self));
	g_return_if_fail (image_path != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				GPtrArray* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				AddImageButton* btn = NULL;
				GPtrArray* _tmp6_;
				gint _tmp7_;
				gconstpointer _tmp8_;
				AddImageButton* _tmp9_;
				AddImageButton* _tmp10_;
				const gchar* _tmp11_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				_tmp3_ = self->priv->buttons;
				_tmp4_ = g_ptr_array_get_length (_tmp3_);
				_tmp5_ = _tmp4_;
				if (!(_tmp2_ < _tmp5_)) {
					break;
				}
				_tmp6_ = self->priv->buttons;
				_tmp7_ = i;
				_tmp8_ = g_ptr_array_index (_tmp6_, (guint) _tmp7_);
				_tmp9_ = _g_object_ref0 ((AddImageButton*) _tmp8_);
				btn = _tmp9_;
				_tmp10_ = btn;
				_tmp11_ = _tmp10_->image_path;
				if (g_strcmp0 (_tmp11_, image_path) == 0) {
					GtkProgressBar* progress_bar = NULL;
					GPtrArray* _tmp12_;
					gint _tmp13_;
					gconstpointer _tmp14_;
					GtkProgressBar* _tmp15_;
					GtkProgressBar* _tmp16_;
					_tmp12_ = self->priv->progress_bars;
					_tmp13_ = i;
					_tmp14_ = g_ptr_array_index (_tmp12_, (guint) _tmp13_);
					_tmp15_ = _g_object_ref0 ((GtkProgressBar*) _tmp14_);
					progress_bar = _tmp15_;
					_tmp16_ = progress_bar;
					gtk_progress_bar_set_fraction (_tmp16_, progress);
					if (progress == 1.0) {
						GtkProgressBar* _tmp17_;
						_tmp17_ = progress_bar;
						gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_widget_get_type (), GtkWidget));
					}
					_g_object_unref0 (progress_bar);
					_g_object_unref0 (btn);
					break;
				}
				_g_object_unref0 (btn);
			}
		}
	}
}


void
compose_image_manager_end_progress (ComposeImageManager* self,
                                    const gchar* image_path,
                                    const gchar* error_message)
{
	g_return_if_fail (IS_COMPOSE_IMAGE_MANAGER (self));
	g_return_if_fail (image_path != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				GPtrArray* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				AddImageButton* btn = NULL;
				GPtrArray* _tmp6_;
				gint _tmp7_;
				gconstpointer _tmp8_;
				AddImageButton* _tmp9_;
				AddImageButton* _tmp10_;
				const gchar* _tmp11_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				_tmp3_ = self->priv->buttons;
				_tmp4_ = g_ptr_array_get_length (_tmp3_);
				_tmp5_ = _tmp4_;
				if (!(_tmp2_ < _tmp5_)) {
					break;
				}
				_tmp6_ = self->priv->buttons;
				_tmp7_ = i;
				_tmp8_ = g_ptr_array_index (_tmp6_, (guint) _tmp7_);
				_tmp9_ = _g_object_ref0 ((AddImageButton*) _tmp8_);
				btn = _tmp9_;
				_tmp10_ = btn;
				_tmp11_ = _tmp10_->image_path;
				if (g_strcmp0 (_tmp11_, image_path) == 0) {
					AddImageButton* _tmp12_;
					GtkStyleContext* _tmp13_;
					_tmp12_ = btn;
					_tmp13_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget));
					gtk_style_context_remove_class (_tmp13_, "image-progress");
					if (error_message == NULL) {
						AddImageButton* _tmp14_;
						GtkStyleContext* _tmp15_;
						_tmp14_ = btn;
						_tmp15_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_widget_get_type (), GtkWidget));
						gtk_style_context_add_class (_tmp15_, "image-success");
					} else {
						AddImageButton* _tmp16_;
						GtkStyleContext* _tmp17_;
						g_warning ("ComposeImageManager.vala:316: %s: %s", image_path, error_message);
						_tmp16_ = btn;
						_tmp17_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_widget_get_type (), GtkWidget));
						gtk_style_context_add_class (_tmp17_, "image-error");
					}
					_g_object_unref0 (btn);
					break;
				}
				_g_object_unref0 (btn);
			}
		}
	}
}


void
compose_image_manager_insensitivize_buttons (ComposeImageManager* self)
{
	g_return_if_fail (IS_COMPOSE_IMAGE_MANAGER (self));
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				GPtrArray* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				GPtrArray* _tmp6_;
				gint _tmp7_;
				gconstpointer _tmp8_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				_tmp3_ = self->priv->close_buttons;
				_tmp4_ = g_ptr_array_get_length (_tmp3_);
				_tmp5_ = _tmp4_;
				if (!(_tmp2_ < _tmp5_)) {
					break;
				}
				_tmp6_ = self->priv->close_buttons;
				_tmp7_ = i;
				_tmp8_ = g_ptr_array_index (_tmp6_, (guint) _tmp7_);
				gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST ((GtkButton*) _tmp8_, gtk_widget_get_type (), GtkWidget), FALSE);
			}
		}
	}
}


ComposeImageManager*
compose_image_manager_construct (GType object_type)
{
	ComposeImageManager * self = NULL;
	self = (ComposeImageManager*) g_object_new (object_type, NULL);
	return self;
}


ComposeImageManager*
compose_image_manager_new (void)
{
	return compose_image_manager_construct (TYPE_COMPOSE_IMAGE_MANAGER);
}


gint
compose_image_manager_get_n_images (ComposeImageManager* self)
{
	gint result;
	GPtrArray* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (IS_COMPOSE_IMAGE_MANAGER (self), 0);
	_tmp0_ = self->priv->buttons;
	_tmp1_ = g_ptr_array_get_length (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


gboolean
compose_image_manager_get_has_gif (ComposeImageManager* self)
{
	gboolean result;
	g_return_val_if_fail (IS_COMPOSE_IMAGE_MANAGER (self), FALSE);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				GPtrArray* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				GPtrArray* _tmp6_;
				gint _tmp7_;
				gconstpointer _tmp8_;
				const gchar* _tmp9_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				_tmp3_ = self->priv->buttons;
				_tmp4_ = g_ptr_array_get_length (_tmp3_);
				_tmp5_ = _tmp4_;
				if (!(_tmp2_ < _tmp5_)) {
					break;
				}
				_tmp6_ = self->priv->buttons;
				_tmp7_ = i;
				_tmp8_ = g_ptr_array_index (_tmp6_, (guint) _tmp7_);
				_tmp9_ = ((AddImageButton*) _tmp8_)->image_path;
				if (g_str_has_suffix (_tmp9_, ".gif")) {
					result = TRUE;
					return result;
				}
			}
		}
	}
	result = FALSE;
	return result;
}


gboolean
compose_image_manager_get_full (ComposeImageManager* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	GPtrArray* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	g_return_val_if_fail (IS_COMPOSE_IMAGE_MANAGER (self), FALSE);
	_tmp1_ = self->priv->buttons;
	_tmp2_ = g_ptr_array_get_length (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == TWITTER_max_media_per_upload) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp4_ = compose_image_manager_get_has_gif (self);
		_tmp5_ = _tmp4_;
		_tmp0_ = _tmp5_;
	}
	result = _tmp0_;
	return result;
}


static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static GObject *
compose_image_manager_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ComposeImageManager * self;
	GPtrArray* _tmp0_;
	GPtrArray* _tmp1_;
	GPtrArray* _tmp2_;
	parent_class = G_OBJECT_CLASS (compose_image_manager_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COMPOSE_IMAGE_MANAGER, ComposeImageManager);
	_tmp0_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
	_g_ptr_array_unref0 (self->priv->buttons);
	self->priv->buttons = _tmp0_;
	_tmp1_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
	_g_ptr_array_unref0 (self->priv->close_buttons);
	self->priv->close_buttons = _tmp1_;
	_tmp2_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
	_g_ptr_array_unref0 (self->priv->progress_bars);
	self->priv->progress_bars = _tmp2_;
	gtk_widget_set_has_window (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), FALSE);
	return obj;
}


static void
compose_image_manager_class_init (ComposeImageManagerClass * klass)
{
	compose_image_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ComposeImageManagerPrivate));
	((GtkContainerClass *) klass)->forall = (void (*) (GtkContainer *, gboolean, GtkCallback, void*)) compose_image_manager_real_forall_internal;
	((GtkContainerClass *) klass)->add = (void (*) (GtkContainer *, GtkWidget*)) compose_image_manager_real_add;
	((GtkContainerClass *) klass)->remove = (void (*) (GtkContainer *, GtkWidget*)) compose_image_manager_real_remove;
	((GtkWidgetClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkWidget *)) compose_image_manager_real_get_request_mode;
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget *, GtkAllocation*)) compose_image_manager_real_size_allocate;
	((GtkWidgetClass *) klass)->get_preferred_height_for_width = (void (*) (GtkWidget *, gint, gint*, gint*)) compose_image_manager_real_get_preferred_height_for_width;
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget *, gint*, gint*)) compose_image_manager_real_get_preferred_height;
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget *, gint*, gint*)) compose_image_manager_real_get_preferred_width;
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget *, cairo_t*)) compose_image_manager_real_draw;
	G_OBJECT_CLASS (klass)->get_property = _vala_compose_image_manager_get_property;
	G_OBJECT_CLASS (klass)->constructor = compose_image_manager_constructor;
	G_OBJECT_CLASS (klass)->finalize = compose_image_manager_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), COMPOSE_IMAGE_MANAGER_N_IMAGES_PROPERTY, compose_image_manager_properties[COMPOSE_IMAGE_MANAGER_N_IMAGES_PROPERTY] = g_param_spec_int ("n-images", "n-images", "n-images", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), COMPOSE_IMAGE_MANAGER_HAS_GIF_PROPERTY, compose_image_manager_properties[COMPOSE_IMAGE_MANAGER_HAS_GIF_PROPERTY] = g_param_spec_boolean ("has-gif", "has-gif", "has-gif", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), COMPOSE_IMAGE_MANAGER_FULL_PROPERTY, compose_image_manager_properties[COMPOSE_IMAGE_MANAGER_FULL_PROPERTY] = g_param_spec_boolean ("full", "full", "full", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	compose_image_manager_signals[COMPOSE_IMAGE_MANAGER_IMAGE_REMOVED_SIGNAL] = g_signal_new ("image-removed", TYPE_COMPOSE_IMAGE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
}


static void
compose_image_manager_instance_init (ComposeImageManager * self)
{
	self->priv = COMPOSE_IMAGE_MANAGER_GET_PRIVATE (self);
}


static void
compose_image_manager_finalize (GObject * obj)
{
	ComposeImageManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COMPOSE_IMAGE_MANAGER, ComposeImageManager);
	_g_ptr_array_unref0 (self->priv->buttons);
	_g_ptr_array_unref0 (self->priv->close_buttons);
	_g_ptr_array_unref0 (self->priv->progress_bars);
	G_OBJECT_CLASS (compose_image_manager_parent_class)->finalize (obj);
}


GType
compose_image_manager_get_type (void)
{
	static volatile gsize compose_image_manager_type_id__volatile = 0;
	if (g_once_init_enter (&compose_image_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ComposeImageManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) compose_image_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ComposeImageManager), 0, (GInstanceInitFunc) compose_image_manager_instance_init, NULL };
		GType compose_image_manager_type_id;
		compose_image_manager_type_id = g_type_register_static (gtk_container_get_type (), "ComposeImageManager", &g_define_type_info, 0);
		g_once_init_leave (&compose_image_manager_type_id__volatile, compose_image_manager_type_id);
	}
	return compose_image_manager_type_id__volatile;
}


static void
_vala_compose_image_manager_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	ComposeImageManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_COMPOSE_IMAGE_MANAGER, ComposeImageManager);
	switch (property_id) {
		case COMPOSE_IMAGE_MANAGER_N_IMAGES_PROPERTY:
		g_value_set_int (value, compose_image_manager_get_n_images (self));
		break;
		case COMPOSE_IMAGE_MANAGER_HAS_GIF_PROPERTY:
		g_value_set_boolean (value, compose_image_manager_get_has_gif (self));
		break;
		case COMPOSE_IMAGE_MANAGER_FULL_PROPERTY:
		g_value_set_boolean (value, compose_image_manager_get_full (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



