/* CropWidget.c generated by valac 0.40.0, the Vala compiler
 * generated from CropWidget.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <cairo.h>
#include <string.h>


#define TYPE_CROP_WIDGET (crop_widget_get_type ())
#define CROP_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CROP_WIDGET, CropWidget))
#define CROP_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CROP_WIDGET, CropWidgetClass))
#define IS_CROP_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CROP_WIDGET))
#define IS_CROP_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CROP_WIDGET))
#define CROP_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CROP_WIDGET, CropWidgetClass))

typedef struct _CropWidget CropWidget;
typedef struct _CropWidgetClass CropWidgetClass;
typedef struct _CropWidgetPrivate CropWidgetPrivate;
enum  {
	CROP_WIDGET_0_PROPERTY,
	CROP_WIDGET_DESIRED_ASPECT_RATIO_PROPERTY,
	CROP_WIDGET_NUM_PROPERTIES
};
static GParamSpec* crop_widget_properties[CROP_WIDGET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _CropWidget {
	GtkDrawingArea parent_instance;
	CropWidgetPrivate * priv;
};

struct _CropWidgetClass {
	GtkDrawingAreaClass parent_class;
};

struct _CropWidgetPrivate {
	GtkGestureDrag* drag_gesture;
	GdkPixbuf* image;
	GdkRectangle selection_rect;
	GdkRectangle image_rect;
	GdkCursor* drag_cursor;
	GdkCursor* default_cursor;
	GdkCursor* resize_cursor;
	gboolean selection_grabbed;
	gboolean resize_area_grabbed;
	gint drag_diff_x;
	gint drag_diff_y;
	gint resize_diff_x;
	gint resize_diff_y;
	gboolean resize_area_hovered;
	gdouble current_scale;
	gint min_width;
	gdouble drag_start_x;
	gdouble drag_start_y;
	gdouble _desired_aspect_ratio;
};


static gpointer crop_widget_parent_class = NULL;

GType crop_widget_get_type (void) G_GNUC_CONST;
#define CROP_WIDGET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CROP_WIDGET, CropWidgetPrivate))
#define CROP_WIDGET_MIN_SIZE 48
static gboolean crop_widget_mouse_motion_cb (CropWidget* self,
                                      GdkEventMotion* event);
static gboolean crop_widget_over_resize_area (CropWidget* self,
                                       gdouble x,
                                       gdouble y);
static inline void crop_widget_set_cursor (CropWidget* self,
                             GdkCursor* cursor);
static gboolean crop_widget_cursor_in_selection (CropWidget* self,
                                          gdouble x,
                                          gdouble y);
static void crop_widget_drag_gesture_update_cb (CropWidget* self,
                                         GtkGestureDrag* gesture,
                                         gdouble offset_x,
                                         gdouble offset_y);
static void crop_widget_resize_selection_rect (CropWidget* self,
                                        gdouble x,
                                        gdouble y);
static void crop_widget_drag_gesture_begin_cb (CropWidget* self,
                                        GtkGestureDrag* gesture,
                                        gdouble x,
                                        gdouble y);
static void crop_widget_drag_gesture_end_cb (CropWidget* self,
                                      GtkGestureDrag* gesture,
                                      gdouble offset_x,
                                      gdouble offset_y);
static inline void crop_widget_restrict_selection_size (CropWidget* self);
gdouble crop_widget_get_desired_aspect_ratio (CropWidget* self);
void crop_widget_set_image (CropWidget* self,
                            GdkPixbuf* image);
static void crop_widget_calculate_image_rect (CropWidget* self);
static gboolean crop_widget_real_draw (GtkWidget* base,
                                cairo_t* ct);
static void crop_widget_real_size_allocate (GtkWidget* base,
                                     GtkAllocation* alloc);
GdkPixbuf* crop_widget_get_cropped_image (CropWidget* self);
void crop_widget_set_min_size (CropWidget* self,
                               gint min_width);
CropWidget* crop_widget_new (void);
CropWidget* crop_widget_construct (GType object_type);
void crop_widget_set_desired_aspect_ratio (CropWidget* self,
                                           gdouble value);
static GObject * crop_widget_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static gboolean _crop_widget_mouse_motion_cb_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                      GdkEventMotion* event,
                                                                      gpointer self);
static void _crop_widget_drag_gesture_begin_cb_gtk_gesture_drag_drag_begin (GtkGestureDrag* _sender,
                                                                     gdouble start_x,
                                                                     gdouble start_y,
                                                                     gpointer self);
static void _crop_widget_drag_gesture_end_cb_gtk_gesture_drag_drag_end (GtkGestureDrag* _sender,
                                                                 gdouble offset_x,
                                                                 gdouble offset_y,
                                                                 gpointer self);
static void _crop_widget_drag_gesture_update_cb_gtk_gesture_drag_drag_update (GtkGestureDrag* _sender,
                                                                       gdouble offset_x,
                                                                       gdouble offset_y,
                                                                       gpointer self);
static void crop_widget_finalize (GObject * obj);
static void _vala_crop_widget_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_crop_widget_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);


static gboolean
crop_widget_mouse_motion_cb (CropWidget* self,
                             GdkEventMotion* event)
{
	gboolean result = FALSE;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	g_return_val_if_fail (IS_CROP_WIDGET (self), FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event->x;
	_tmp1_ = event->y;
	if (crop_widget_over_resize_area (self, _tmp0_, _tmp1_)) {
		GdkCursor* _tmp2_;
		_tmp2_ = self->priv->resize_cursor;
		crop_widget_set_cursor (self, _tmp2_);
		self->priv->resize_area_hovered = TRUE;
		gtk_widget_queue_draw (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
		result = FALSE;
		return result;
	} else {
		gboolean _tmp3_;
		_tmp3_ = self->priv->resize_area_hovered;
		if (_tmp3_) {
			GdkCursor* _tmp4_;
			self->priv->resize_area_hovered = FALSE;
			_tmp4_ = self->priv->default_cursor;
			crop_widget_set_cursor (self, _tmp4_);
			gtk_widget_queue_draw (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
		}
	}
	_tmp5_ = event->x;
	_tmp6_ = event->y;
	if (crop_widget_cursor_in_selection (self, _tmp5_, _tmp6_)) {
		GdkCursor* _tmp7_;
		_tmp7_ = self->priv->drag_cursor;
		crop_widget_set_cursor (self, _tmp7_);
	} else {
		GdkCursor* _tmp8_;
		_tmp8_ = self->priv->default_cursor;
		crop_widget_set_cursor (self, _tmp8_);
	}
	result = FALSE;
	return result;
}


static void
crop_widget_drag_gesture_update_cb (CropWidget* self,
                                    GtkGestureDrag* gesture,
                                    gdouble offset_x,
                                    gdouble offset_y)
{
	gdouble x = 0.0;
	gdouble _tmp0_;
	gdouble y = 0.0;
	gdouble _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp5_;
	g_return_if_fail (IS_CROP_WIDGET (self));
	g_return_if_fail (GTK_IS_GESTURE_DRAG (gesture));
	_tmp0_ = self->priv->drag_start_x;
	x = _tmp0_ + offset_x;
	_tmp1_ = self->priv->drag_start_y;
	y = _tmp1_ + offset_y;
	_tmp2_ = self->priv->resize_area_grabbed;
	if (_tmp2_) {
		gdouble _tmp3_;
		gdouble _tmp4_;
		_tmp3_ = x;
		_tmp4_ = y;
		crop_widget_resize_selection_rect (self, _tmp3_, _tmp4_);
	}
	_tmp5_ = self->priv->selection_grabbed;
	if (_tmp5_) {
		gdouble _tmp6_;
		gint _tmp7_;
		gdouble _tmp8_;
		gint _tmp9_;
		GdkRectangle _tmp10_;
		gint _tmp11_;
		GdkRectangle _tmp12_;
		gint _tmp13_;
		GdkRectangle _tmp16_;
		gint _tmp17_;
		GdkRectangle _tmp18_;
		gint _tmp19_;
		GdkRectangle _tmp22_;
		gint _tmp23_;
		GdkRectangle _tmp24_;
		gint _tmp25_;
		GdkRectangle _tmp26_;
		gint _tmp27_;
		GdkRectangle _tmp28_;
		gint _tmp29_;
		GdkRectangle _tmp36_;
		gint _tmp37_;
		GdkRectangle _tmp38_;
		gint _tmp39_;
		GdkRectangle _tmp40_;
		gint _tmp41_;
		GdkRectangle _tmp42_;
		gint _tmp43_;
		_tmp6_ = x;
		_tmp7_ = self->priv->drag_diff_x;
		self->priv->selection_rect.x = ((gint) _tmp6_) - _tmp7_;
		_tmp8_ = y;
		_tmp9_ = self->priv->drag_diff_y;
		self->priv->selection_rect.y = ((gint) _tmp8_) - _tmp9_;
		_tmp10_ = self->priv->selection_rect;
		_tmp11_ = _tmp10_.x;
		_tmp12_ = self->priv->image_rect;
		_tmp13_ = _tmp12_.x;
		if (_tmp11_ < _tmp13_) {
			GdkRectangle _tmp14_;
			gint _tmp15_;
			_tmp14_ = self->priv->image_rect;
			_tmp15_ = _tmp14_.x;
			self->priv->selection_rect.x = _tmp15_;
		}
		_tmp16_ = self->priv->selection_rect;
		_tmp17_ = _tmp16_.y;
		_tmp18_ = self->priv->image_rect;
		_tmp19_ = _tmp18_.y;
		if (_tmp17_ < _tmp19_) {
			GdkRectangle _tmp20_;
			gint _tmp21_;
			_tmp20_ = self->priv->image_rect;
			_tmp21_ = _tmp20_.y;
			self->priv->selection_rect.y = _tmp21_;
		}
		_tmp22_ = self->priv->selection_rect;
		_tmp23_ = _tmp22_.x;
		_tmp24_ = self->priv->selection_rect;
		_tmp25_ = _tmp24_.width;
		_tmp26_ = self->priv->image_rect;
		_tmp27_ = _tmp26_.x;
		_tmp28_ = self->priv->image_rect;
		_tmp29_ = _tmp28_.width;
		if ((_tmp23_ + _tmp25_) > (_tmp27_ + _tmp29_)) {
			GdkRectangle _tmp30_;
			gint _tmp31_;
			GdkRectangle _tmp32_;
			gint _tmp33_;
			GdkRectangle _tmp34_;
			gint _tmp35_;
			_tmp30_ = self->priv->image_rect;
			_tmp31_ = _tmp30_.x;
			_tmp32_ = self->priv->image_rect;
			_tmp33_ = _tmp32_.width;
			_tmp34_ = self->priv->selection_rect;
			_tmp35_ = _tmp34_.width;
			self->priv->selection_rect.x = (_tmp31_ + _tmp33_) - _tmp35_;
		}
		_tmp36_ = self->priv->selection_rect;
		_tmp37_ = _tmp36_.y;
		_tmp38_ = self->priv->selection_rect;
		_tmp39_ = _tmp38_.height;
		_tmp40_ = self->priv->image_rect;
		_tmp41_ = _tmp40_.y;
		_tmp42_ = self->priv->image_rect;
		_tmp43_ = _tmp42_.height;
		if ((_tmp37_ + _tmp39_) > (_tmp41_ + _tmp43_)) {
			GdkRectangle _tmp44_;
			gint _tmp45_;
			GdkRectangle _tmp46_;
			gint _tmp47_;
			GdkRectangle _tmp48_;
			gint _tmp49_;
			_tmp44_ = self->priv->image_rect;
			_tmp45_ = _tmp44_.y;
			_tmp46_ = self->priv->image_rect;
			_tmp47_ = _tmp46_.height;
			_tmp48_ = self->priv->selection_rect;
			_tmp49_ = _tmp48_.height;
			self->priv->selection_rect.y = (_tmp45_ + _tmp47_) - _tmp49_;
		}
		gtk_widget_queue_draw (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
		return;
	}
}


static void
crop_widget_drag_gesture_begin_cb (CropWidget* self,
                                   GtkGestureDrag* gesture,
                                   gdouble x,
                                   gdouble y)
{
	g_return_if_fail (IS_CROP_WIDGET (self));
	g_return_if_fail (GTK_IS_GESTURE_DRAG (gesture));
	self->priv->drag_start_x = x;
	self->priv->drag_start_y = y;
	if (crop_widget_over_resize_area (self, x, y)) {
		GdkRectangle _tmp0_;
		gint _tmp1_;
		GdkRectangle _tmp2_;
		gint _tmp3_;
		GdkRectangle _tmp4_;
		gint _tmp5_;
		GdkRectangle _tmp6_;
		gint _tmp7_;
		GdkCursor* _tmp8_;
		self->priv->resize_area_grabbed = TRUE;
		_tmp0_ = self->priv->selection_rect;
		_tmp1_ = _tmp0_.x;
		_tmp2_ = self->priv->selection_rect;
		_tmp3_ = _tmp2_.width;
		self->priv->resize_diff_x = ((gint) x) - (_tmp1_ + _tmp3_);
		_tmp4_ = self->priv->selection_rect;
		_tmp5_ = _tmp4_.y;
		_tmp6_ = self->priv->selection_rect;
		_tmp7_ = _tmp6_.height;
		self->priv->resize_diff_y = ((gint) y) - (_tmp5_ + _tmp7_);
		gtk_gesture_set_state (G_TYPE_CHECK_INSTANCE_CAST (gesture, gtk_gesture_get_type (), GtkGesture), GTK_EVENT_SEQUENCE_CLAIMED);
		_tmp8_ = self->priv->resize_cursor;
		crop_widget_set_cursor (self, _tmp8_);
		return;
	}
	if (crop_widget_cursor_in_selection (self, x, y)) {
		GdkRectangle _tmp9_;
		gint _tmp10_;
		GdkRectangle _tmp11_;
		gint _tmp12_;
		GdkCursor* _tmp13_;
		self->priv->selection_grabbed = TRUE;
		_tmp9_ = self->priv->selection_rect;
		_tmp10_ = _tmp9_.x;
		self->priv->drag_diff_x = (gint) (x - _tmp10_);
		_tmp11_ = self->priv->selection_rect;
		_tmp12_ = _tmp11_.y;
		self->priv->drag_diff_y = (gint) (y - _tmp12_);
		gtk_gesture_set_state (G_TYPE_CHECK_INSTANCE_CAST (gesture, gtk_gesture_get_type (), GtkGesture), GTK_EVENT_SEQUENCE_CLAIMED);
		_tmp13_ = self->priv->drag_cursor;
		crop_widget_set_cursor (self, _tmp13_);
		return;
	}
	gtk_gesture_set_state (G_TYPE_CHECK_INSTANCE_CAST (gesture, gtk_gesture_get_type (), GtkGesture), GTK_EVENT_SEQUENCE_DENIED);
}


static void
crop_widget_drag_gesture_end_cb (CropWidget* self,
                                 GtkGestureDrag* gesture,
                                 gdouble offset_x,
                                 gdouble offset_y)
{
	gboolean _tmp0_;
	gboolean _tmp2_;
	g_return_if_fail (IS_CROP_WIDGET (self));
	g_return_if_fail (GTK_IS_GESTURE_DRAG (gesture));
	_tmp0_ = self->priv->selection_grabbed;
	if (_tmp0_) {
		GdkCursor* _tmp1_;
		self->priv->selection_grabbed = FALSE;
		_tmp1_ = self->priv->default_cursor;
		crop_widget_set_cursor (self, _tmp1_);
		return;
	}
	_tmp2_ = self->priv->resize_area_grabbed;
	if (_tmp2_) {
		GdkCursor* _tmp3_;
		self->priv->resize_area_grabbed = FALSE;
		_tmp3_ = self->priv->default_cursor;
		crop_widget_set_cursor (self, _tmp3_);
		return;
	}
}


static inline void
crop_widget_restrict_selection_size (CropWidget* self)
{
	GdkRectangle _tmp0_;
	gint _tmp1_;
	GdkRectangle _tmp2_;
	gint _tmp3_;
	GdkRectangle _tmp6_;
	gint _tmp7_;
	GdkRectangle _tmp8_;
	gint _tmp9_;
	GdkRectangle _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gdouble _tmp15_;
	GdkRectangle _tmp21_;
	gint _tmp22_;
	GdkRectangle _tmp23_;
	gint _tmp24_;
	GdkRectangle _tmp27_;
	gint _tmp28_;
	GdkRectangle _tmp29_;
	gint _tmp30_;
	GdkRectangle _tmp33_;
	gint _tmp34_;
	GdkRectangle _tmp35_;
	gint _tmp36_;
	GdkRectangle _tmp37_;
	gint _tmp38_;
	GdkRectangle _tmp39_;
	gint _tmp40_;
	GdkRectangle _tmp47_;
	gint _tmp48_;
	GdkRectangle _tmp49_;
	gint _tmp50_;
	GdkRectangle _tmp51_;
	gint _tmp52_;
	GdkRectangle _tmp53_;
	gint _tmp54_;
	g_return_if_fail (IS_CROP_WIDGET (self));
	_tmp0_ = self->priv->selection_rect;
	_tmp1_ = _tmp0_.width;
	_tmp2_ = self->priv->image_rect;
	_tmp3_ = _tmp2_.width;
	if (_tmp1_ > _tmp3_) {
		GdkRectangle _tmp4_;
		gint _tmp5_;
		_tmp4_ = self->priv->image_rect;
		_tmp5_ = _tmp4_.width;
		self->priv->selection_rect.width = _tmp5_;
	}
	_tmp6_ = self->priv->selection_rect;
	_tmp7_ = _tmp6_.height;
	_tmp8_ = self->priv->image_rect;
	_tmp9_ = _tmp8_.height;
	if (_tmp7_ > _tmp9_) {
		GdkRectangle _tmp10_;
		gint _tmp11_;
		_tmp10_ = self->priv->image_rect;
		_tmp11_ = _tmp10_.height;
		self->priv->selection_rect.height = _tmp11_;
	}
	_tmp12_ = self->priv->selection_rect;
	_tmp13_ = _tmp12_.width;
	_tmp14_ = self->priv->min_width;
	_tmp15_ = self->priv->current_scale;
	if (((gdouble) _tmp13_) < (_tmp14_ * _tmp15_)) {
		gint _tmp16_;
		gdouble _tmp17_;
		gint _tmp18_;
		gdouble _tmp19_;
		gdouble _tmp20_;
		_tmp16_ = self->priv->min_width;
		_tmp17_ = self->priv->current_scale;
		self->priv->selection_rect.width = (gint) (_tmp16_ * _tmp17_);
		_tmp18_ = self->priv->min_width;
		_tmp19_ = self->priv->current_scale;
		_tmp20_ = self->priv->_desired_aspect_ratio;
		self->priv->selection_rect.height = (gint) ((_tmp18_ * _tmp19_) / _tmp20_);
	}
	_tmp21_ = self->priv->selection_rect;
	_tmp22_ = _tmp21_.x;
	_tmp23_ = self->priv->image_rect;
	_tmp24_ = _tmp23_.x;
	if (_tmp22_ < _tmp24_) {
		GdkRectangle _tmp25_;
		gint _tmp26_;
		_tmp25_ = self->priv->image_rect;
		_tmp26_ = _tmp25_.x;
		self->priv->selection_rect.x = _tmp26_;
	}
	_tmp27_ = self->priv->selection_rect;
	_tmp28_ = _tmp27_.y;
	_tmp29_ = self->priv->image_rect;
	_tmp30_ = _tmp29_.y;
	if (_tmp28_ < _tmp30_) {
		GdkRectangle _tmp31_;
		gint _tmp32_;
		_tmp31_ = self->priv->image_rect;
		_tmp32_ = _tmp31_.y;
		self->priv->selection_rect.y = _tmp32_;
	}
	_tmp33_ = self->priv->selection_rect;
	_tmp34_ = _tmp33_.x;
	_tmp35_ = self->priv->selection_rect;
	_tmp36_ = _tmp35_.width;
	_tmp37_ = self->priv->image_rect;
	_tmp38_ = _tmp37_.x;
	_tmp39_ = self->priv->image_rect;
	_tmp40_ = _tmp39_.width;
	if ((_tmp34_ + _tmp36_) > (_tmp38_ + _tmp40_)) {
		GdkRectangle _tmp41_;
		gint _tmp42_;
		GdkRectangle _tmp43_;
		gint _tmp44_;
		GdkRectangle _tmp45_;
		gint _tmp46_;
		_tmp41_ = self->priv->image_rect;
		_tmp42_ = _tmp41_.x;
		_tmp43_ = self->priv->image_rect;
		_tmp44_ = _tmp43_.width;
		_tmp45_ = self->priv->selection_rect;
		_tmp46_ = _tmp45_.width;
		self->priv->selection_rect.x = (_tmp42_ + _tmp44_) - _tmp46_;
	}
	_tmp47_ = self->priv->selection_rect;
	_tmp48_ = _tmp47_.y;
	_tmp49_ = self->priv->selection_rect;
	_tmp50_ = _tmp49_.height;
	_tmp51_ = self->priv->image_rect;
	_tmp52_ = _tmp51_.y;
	_tmp53_ = self->priv->image_rect;
	_tmp54_ = _tmp53_.height;
	if ((_tmp48_ + _tmp50_) > (_tmp52_ + _tmp54_)) {
		GdkRectangle _tmp55_;
		gint _tmp56_;
		GdkRectangle _tmp57_;
		gint _tmp58_;
		GdkRectangle _tmp59_;
		gint _tmp60_;
		_tmp55_ = self->priv->image_rect;
		_tmp56_ = _tmp55_.y;
		_tmp57_ = self->priv->image_rect;
		_tmp58_ = _tmp57_.height;
		_tmp59_ = self->priv->selection_rect;
		_tmp60_ = _tmp59_.height;
		self->priv->selection_rect.y = (_tmp56_ + _tmp58_) - _tmp60_;
	}
}


static void
crop_widget_resize_selection_rect (CropWidget* self,
                                   gdouble x,
                                   gdouble y)
{
	gboolean _tmp0_;
	gint max_width = 0;
	GdkRectangle _tmp1_;
	gint _tmp2_;
	GdkRectangle _tmp3_;
	gint _tmp4_;
	GdkRectangle _tmp5_;
	gint _tmp6_;
	gdouble _tmp7_;
	gint new_width = 0;
	GdkRectangle _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint new_height = 0;
	gint _tmp11_;
	gdouble _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	g_return_if_fail (IS_CROP_WIDGET (self));
	_tmp0_ = self->priv->resize_area_grabbed;
	if (!_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->image_rect;
	_tmp2_ = _tmp1_.width;
	_tmp3_ = self->priv->image_rect;
	_tmp4_ = _tmp3_.width;
	_tmp5_ = self->priv->image_rect;
	_tmp6_ = _tmp5_.height;
	_tmp7_ = self->priv->_desired_aspect_ratio;
	max_width = MIN (_tmp2_, MIN ((gint) _tmp4_, (gint) (_tmp6_ * _tmp7_)));
	_tmp8_ = self->priv->selection_rect;
	_tmp9_ = _tmp8_.x;
	_tmp10_ = self->priv->resize_diff_x;
	new_width = (((gint) x) - _tmp9_) - _tmp10_;
	_tmp11_ = new_width;
	_tmp12_ = self->priv->_desired_aspect_ratio;
	new_height = (gint) (_tmp11_ / _tmp12_);
	_tmp13_ = new_width;
	_tmp14_ = max_width;
	if (_tmp13_ <= _tmp14_) {
		gint _tmp15_;
		gint _tmp16_;
		_tmp15_ = new_width;
		self->priv->selection_rect.width = _tmp15_;
		_tmp16_ = new_height;
		self->priv->selection_rect.height = _tmp16_;
	} else {
		gint _tmp17_;
		gint _tmp18_;
		gdouble _tmp19_;
		_tmp17_ = max_width;
		self->priv->selection_rect.width = _tmp17_;
		_tmp18_ = max_width;
		_tmp19_ = self->priv->_desired_aspect_ratio;
		self->priv->selection_rect.height = (gint) (_tmp18_ / _tmp19_);
	}
	crop_widget_restrict_selection_size (self);
	gtk_widget_queue_draw (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


void
crop_widget_set_image (CropWidget* self,
                       GdkPixbuf* image)
{
	GdkPixbuf* _tmp0_;
	GdkRectangle _tmp1_;
	gint _tmp2_;
	GdkRectangle _tmp3_;
	gint _tmp4_;
	gdouble _tmp5_;
	GdkRectangle _tmp6_;
	gint _tmp7_;
	GdkRectangle _tmp8_;
	gint _tmp9_;
	GdkRectangle _tmp15_;
	gint _tmp16_;
	GdkRectangle _tmp17_;
	gint _tmp18_;
	GdkRectangle _tmp19_;
	gint _tmp20_;
	GdkRectangle _tmp21_;
	gint _tmp22_;
	GdkRectangle _tmp23_;
	gint _tmp24_;
	GdkRectangle _tmp25_;
	gint _tmp26_;
	g_return_if_fail (IS_CROP_WIDGET (self));
	g_return_if_fail ((image == NULL) || GDK_IS_PIXBUF (image));
	_tmp0_ = _g_object_ref0 (image);
	_g_object_unref0 (self->priv->image);
	self->priv->image = _tmp0_;
	crop_widget_calculate_image_rect (self);
	_tmp1_ = self->priv->image_rect;
	_tmp2_ = _tmp1_.width;
	self->priv->selection_rect.width = _tmp2_;
	_tmp3_ = self->priv->selection_rect;
	_tmp4_ = _tmp3_.width;
	_tmp5_ = self->priv->_desired_aspect_ratio;
	self->priv->selection_rect.height = (gint) (_tmp4_ / _tmp5_);
	_tmp6_ = self->priv->selection_rect;
	_tmp7_ = _tmp6_.height;
	_tmp8_ = self->priv->image_rect;
	_tmp9_ = _tmp8_.height;
	if (_tmp7_ > _tmp9_) {
		GdkRectangle _tmp10_;
		gint _tmp11_;
		GdkRectangle _tmp12_;
		gint _tmp13_;
		gdouble _tmp14_;
		_tmp10_ = self->priv->image_rect;
		_tmp11_ = _tmp10_.height;
		self->priv->selection_rect.height = _tmp11_;
		_tmp12_ = self->priv->selection_rect;
		_tmp13_ = _tmp12_.height;
		_tmp14_ = self->priv->_desired_aspect_ratio;
		self->priv->selection_rect.width = (gint) (_tmp13_ * _tmp14_);
	}
	_tmp15_ = self->priv->image_rect;
	_tmp16_ = _tmp15_.x;
	_tmp17_ = self->priv->image_rect;
	_tmp18_ = _tmp17_.width;
	_tmp19_ = self->priv->selection_rect;
	_tmp20_ = _tmp19_.width;
	self->priv->selection_rect.x = _tmp16_ + ((_tmp18_ - _tmp20_) / 2);
	_tmp21_ = self->priv->image_rect;
	_tmp22_ = _tmp21_.y;
	_tmp23_ = self->priv->image_rect;
	_tmp24_ = _tmp23_.height;
	_tmp25_ = self->priv->selection_rect;
	_tmp26_ = _tmp25_.height;
	self->priv->selection_rect.y = _tmp22_ + ((_tmp24_ - _tmp26_) / 2);
	crop_widget_restrict_selection_size (self);
	gtk_widget_queue_draw (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
}


static gboolean
crop_widget_real_draw (GtkWidget* base,
                       cairo_t* ct)
{
	CropWidget * self;
	gboolean result = FALSE;
	GdkPixbuf* _tmp0_;
	gint widget_width = 0;
	gint widget_height = 0;
	gint _tmp1_;
	gint _tmp2_;
	GdkRectangle _tmp3_;
	gint _tmp4_;
	GdkRectangle _tmp5_;
	gint _tmp6_;
	GdkRectangle _tmp7_;
	gint _tmp8_;
	GdkRectangle _tmp9_;
	gint _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	GdkPixbuf* _tmp13_;
	GdkRectangle _tmp14_;
	gint _tmp15_;
	gdouble _tmp16_;
	GdkRectangle _tmp17_;
	gint _tmp18_;
	gdouble _tmp19_;
	GdkRectangle _tmp20_;
	gint _tmp21_;
	GdkRectangle _tmp22_;
	gint _tmp23_;
	GdkRectangle _tmp24_;
	gint _tmp25_;
	GdkRectangle _tmp26_;
	gint _tmp27_;
	GdkRectangle _tmp28_;
	gint _tmp29_;
	GdkRectangle _tmp30_;
	gint _tmp31_;
	GdkRectangle _tmp32_;
	gint _tmp33_;
	GdkRectangle _tmp34_;
	gint _tmp35_;
	gboolean _tmp36_ = FALSE;
	gboolean _tmp37_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_CROP_WIDGET, CropWidget);
	g_return_val_if_fail (ct != NULL, FALSE);
	_tmp0_ = self->priv->image;
	if (_tmp0_ == NULL) {
		result = GDK_EVENT_PROPAGATE;
		return result;
	}
	widget_width = gtk_widget_get_allocated_width (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	widget_height = gtk_widget_get_allocated_height (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	cairo_set_line_width (ct, 1.0);
	_tmp1_ = widget_width;
	_tmp2_ = widget_height;
	cairo_rectangle (ct, (gdouble) 0, (gdouble) 0, (gdouble) _tmp1_, (gdouble) _tmp2_);
	cairo_set_source_rgba (ct, 0.3, 0.3, 0.3, 1.0);
	cairo_fill (ct);
	cairo_save (ct);
	_tmp3_ = self->priv->image_rect;
	_tmp4_ = _tmp3_.x;
	_tmp5_ = self->priv->image_rect;
	_tmp6_ = _tmp5_.y;
	_tmp7_ = self->priv->image_rect;
	_tmp8_ = _tmp7_.width;
	_tmp9_ = self->priv->image_rect;
	_tmp10_ = _tmp9_.height;
	cairo_rectangle (ct, (gdouble) _tmp4_, (gdouble) _tmp6_, (gdouble) _tmp8_, (gdouble) _tmp10_);
	_tmp11_ = self->priv->current_scale;
	_tmp12_ = self->priv->current_scale;
	cairo_scale (ct, _tmp11_, _tmp12_);
	_tmp13_ = self->priv->image;
	_tmp14_ = self->priv->image_rect;
	_tmp15_ = _tmp14_.x;
	_tmp16_ = self->priv->current_scale;
	_tmp17_ = self->priv->image_rect;
	_tmp18_ = _tmp17_.y;
	_tmp19_ = self->priv->current_scale;
	gdk_cairo_set_source_pixbuf (ct, _tmp13_, _tmp15_ / _tmp16_, _tmp18_ / _tmp19_);
	cairo_fill (ct);
	cairo_restore (ct);
	_tmp20_ = self->priv->selection_rect;
	_tmp21_ = _tmp20_.x;
	_tmp22_ = self->priv->selection_rect;
	_tmp23_ = _tmp22_.y;
	_tmp24_ = self->priv->selection_rect;
	_tmp25_ = _tmp24_.width;
	_tmp26_ = self->priv->selection_rect;
	_tmp27_ = _tmp26_.height;
	cairo_rectangle (ct, (gdouble) _tmp21_, (gdouble) _tmp23_, (gdouble) _tmp25_, (gdouble) _tmp27_);
	cairo_set_source_rgba (ct, 1.0, 1.0, 1.0, 1.0);
	cairo_stroke (ct);
	_tmp28_ = self->priv->selection_rect;
	_tmp29_ = _tmp28_.x;
	_tmp30_ = self->priv->selection_rect;
	_tmp31_ = _tmp30_.width;
	_tmp32_ = self->priv->selection_rect;
	_tmp33_ = _tmp32_.y;
	_tmp34_ = self->priv->selection_rect;
	_tmp35_ = _tmp34_.height;
	cairo_rectangle (ct, (gdouble) ((_tmp29_ + _tmp31_) - 15), (gdouble) ((_tmp33_ + _tmp35_) - 15), 14.5, 14.5);
	_tmp37_ = self->priv->resize_area_hovered;
	if (_tmp37_) {
		_tmp36_ = TRUE;
	} else {
		gboolean _tmp38_;
		_tmp38_ = self->priv->resize_area_grabbed;
		_tmp36_ = _tmp38_;
	}
	if (_tmp36_) {
		cairo_set_source_rgba (ct, 0.0, 0.0, 0.6, 0.7);
	} else {
		cairo_set_source_rgba (ct, 1.0, 1.0, 1.0, 0.7);
	}
	cairo_fill (ct);
	result = GDK_EVENT_PROPAGATE;
	return result;
}


static inline void
crop_widget_set_cursor (CropWidget* self,
                        GdkCursor* cursor)
{
	GdkWindow* _tmp0_;
	g_return_if_fail (IS_CROP_WIDGET (self));
	g_return_if_fail (GDK_IS_CURSOR (cursor));
	_tmp0_ = gtk_widget_get_window (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	gdk_window_set_cursor (_tmp0_, cursor);
}


static gboolean
crop_widget_cursor_in_selection (CropWidget* self,
                                 gdouble x,
                                 gdouble y)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkRectangle _tmp3_;
	gint _tmp4_;
	g_return_val_if_fail (IS_CROP_WIDGET (self), FALSE);
	_tmp3_ = self->priv->selection_rect;
	_tmp4_ = _tmp3_.x;
	if (x >= ((gdouble) _tmp4_)) {
		GdkRectangle _tmp5_;
		gint _tmp6_;
		GdkRectangle _tmp7_;
		gint _tmp8_;
		_tmp5_ = self->priv->selection_rect;
		_tmp6_ = _tmp5_.x;
		_tmp7_ = self->priv->selection_rect;
		_tmp8_ = _tmp7_.width;
		_tmp2_ = x <= ((gdouble) (_tmp6_ + _tmp8_));
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		GdkRectangle _tmp9_;
		gint _tmp10_;
		_tmp9_ = self->priv->selection_rect;
		_tmp10_ = _tmp9_.y;
		_tmp1_ = y >= ((gdouble) _tmp10_);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GdkRectangle _tmp11_;
		gint _tmp12_;
		GdkRectangle _tmp13_;
		gint _tmp14_;
		_tmp11_ = self->priv->selection_rect;
		_tmp12_ = _tmp11_.y;
		_tmp13_ = self->priv->selection_rect;
		_tmp14_ = _tmp13_.height;
		_tmp0_ = y <= ((gdouble) (_tmp12_ + _tmp14_));
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


static void
crop_widget_real_size_allocate (GtkWidget* base,
                                GtkAllocation* alloc)
{
	CropWidget * self;
	GtkAllocation _tmp0_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_CROP_WIDGET, CropWidget);
	g_return_if_fail (alloc != NULL);
	_tmp0_ = *alloc;
	GTK_WIDGET_CLASS (crop_widget_parent_class)->size_allocate (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_drawing_area_get_type (), GtkDrawingArea), gtk_widget_get_type (), GtkWidget), &_tmp0_);
	crop_widget_calculate_image_rect (self);
	crop_widget_restrict_selection_size (self);
}


static void
crop_widget_calculate_image_rect (CropWidget* self)
{
	gint widget_width = 0;
	gint widget_height = 0;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp7_;
	gdouble _tmp8_;
	gint _tmp9_;
	GdkPixbuf* _tmp12_;
	gdouble _tmp13_;
	gint _tmp14_;
	gdouble _tmp17_;
	GdkPixbuf* _tmp18_;
	gdouble _tmp19_;
	GdkPixbuf* _tmp20_;
	gdouble _tmp21_;
	gint _tmp22_;
	GdkRectangle _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	GdkRectangle _tmp26_;
	gint _tmp27_;
	g_return_if_fail (IS_CROP_WIDGET (self));
	widget_width = gtk_widget_get_allocated_width (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	widget_height = gtk_widget_get_allocated_height (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	_tmp0_ = self->priv->image;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = self->priv->image;
	_tmp2_ = self->priv->image;
	if (gdk_pixbuf_get_width (_tmp1_) > gdk_pixbuf_get_height (_tmp2_)) {
		gint _tmp3_;
		GdkPixbuf* _tmp4_;
		_tmp3_ = widget_width;
		_tmp4_ = self->priv->image;
		self->priv->current_scale = ((gdouble) _tmp3_) / gdk_pixbuf_get_width (_tmp4_);
	} else {
		gint _tmp5_;
		GdkPixbuf* _tmp6_;
		_tmp5_ = widget_height;
		_tmp6_ = self->priv->image;
		self->priv->current_scale = ((gdouble) _tmp5_) / gdk_pixbuf_get_height (_tmp6_);
	}
	_tmp7_ = self->priv->image;
	_tmp8_ = self->priv->current_scale;
	_tmp9_ = widget_width;
	if ((gdk_pixbuf_get_width (_tmp7_) * _tmp8_) > ((gdouble) _tmp9_)) {
		gint _tmp10_;
		GdkPixbuf* _tmp11_;
		_tmp10_ = widget_width;
		_tmp11_ = self->priv->image;
		self->priv->current_scale = ((gdouble) _tmp10_) / gdk_pixbuf_get_width (_tmp11_);
	}
	_tmp12_ = self->priv->image;
	_tmp13_ = self->priv->current_scale;
	_tmp14_ = widget_height;
	if ((gdk_pixbuf_get_height (_tmp12_) * _tmp13_) > ((gdouble) _tmp14_)) {
		gint _tmp15_;
		GdkPixbuf* _tmp16_;
		_tmp15_ = widget_height;
		_tmp16_ = self->priv->image;
		self->priv->current_scale = ((gdouble) _tmp15_) / gdk_pixbuf_get_height (_tmp16_);
	}
	_tmp17_ = self->priv->current_scale;
	if (_tmp17_ > 1.0) {
		self->priv->current_scale = 1.0;
	}
	_tmp18_ = self->priv->image;
	_tmp19_ = self->priv->current_scale;
	self->priv->image_rect.width = (gint) (gdk_pixbuf_get_width (_tmp18_) * _tmp19_);
	_tmp20_ = self->priv->image;
	_tmp21_ = self->priv->current_scale;
	self->priv->image_rect.height = (gint) (gdk_pixbuf_get_height (_tmp20_) * _tmp21_);
	_tmp22_ = widget_width;
	_tmp23_ = self->priv->image_rect;
	_tmp24_ = _tmp23_.width;
	self->priv->image_rect.x = (_tmp22_ - _tmp24_) / 2;
	_tmp25_ = widget_height;
	_tmp26_ = self->priv->image_rect;
	_tmp27_ = _tmp26_.height;
	self->priv->image_rect.y = (_tmp25_ - _tmp27_) / 2;
}


static gboolean
crop_widget_over_resize_area (CropWidget* self,
                              gdouble x,
                              gdouble y)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkRectangle _tmp3_;
	gint _tmp4_;
	GdkRectangle _tmp5_;
	gint _tmp6_;
	g_return_val_if_fail (IS_CROP_WIDGET (self), FALSE);
	_tmp3_ = self->priv->selection_rect;
	_tmp4_ = _tmp3_.x;
	_tmp5_ = self->priv->selection_rect;
	_tmp6_ = _tmp5_.width;
	if (x > ((gdouble) ((_tmp4_ + _tmp6_) - 15))) {
		GdkRectangle _tmp7_;
		gint _tmp8_;
		GdkRectangle _tmp9_;
		gint _tmp10_;
		_tmp7_ = self->priv->selection_rect;
		_tmp8_ = _tmp7_.x;
		_tmp9_ = self->priv->selection_rect;
		_tmp10_ = _tmp9_.width;
		_tmp2_ = x < ((gdouble) ((_tmp8_ + _tmp10_) + 5));
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		GdkRectangle _tmp11_;
		gint _tmp12_;
		GdkRectangle _tmp13_;
		gint _tmp14_;
		_tmp11_ = self->priv->selection_rect;
		_tmp12_ = _tmp11_.y;
		_tmp13_ = self->priv->selection_rect;
		_tmp14_ = _tmp13_.height;
		_tmp1_ = y > ((gdouble) ((_tmp12_ + _tmp14_) - 15));
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GdkRectangle _tmp15_;
		gint _tmp16_;
		GdkRectangle _tmp17_;
		gint _tmp18_;
		_tmp15_ = self->priv->selection_rect;
		_tmp16_ = _tmp15_.y;
		_tmp17_ = self->priv->selection_rect;
		_tmp18_ = _tmp17_.height;
		_tmp0_ = y < ((gdouble) ((_tmp16_ + _tmp18_) + 5));
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


GdkPixbuf*
crop_widget_get_cropped_image (CropWidget* self)
{
	GdkPixbuf* result = NULL;
	gint absolute_x = 0;
	GdkRectangle _tmp0_;
	gint _tmp1_;
	GdkRectangle _tmp2_;
	gint _tmp3_;
	gdouble _tmp4_;
	gint absolute_y = 0;
	GdkRectangle _tmp5_;
	gint _tmp6_;
	GdkRectangle _tmp7_;
	gint _tmp8_;
	gdouble _tmp9_;
	gint absolute_w = 0;
	GdkRectangle _tmp10_;
	gint _tmp11_;
	gdouble _tmp12_;
	gint absolute_h = 0;
	GdkRectangle _tmp13_;
	gint _tmp14_;
	gdouble _tmp15_;
	GdkPixbuf* final_image = NULL;
	GdkPixbuf* _tmp16_;
	GdkPixbuf* _tmp17_;
	GdkPixbuf* _tmp18_;
	g_return_val_if_fail (IS_CROP_WIDGET (self), NULL);
	_tmp0_ = self->priv->selection_rect;
	_tmp1_ = _tmp0_.x;
	_tmp2_ = self->priv->image_rect;
	_tmp3_ = _tmp2_.x;
	_tmp4_ = self->priv->current_scale;
	absolute_x = (gint) ((_tmp1_ - _tmp3_) / _tmp4_);
	_tmp5_ = self->priv->selection_rect;
	_tmp6_ = _tmp5_.y;
	_tmp7_ = self->priv->image_rect;
	_tmp8_ = _tmp7_.y;
	_tmp9_ = self->priv->current_scale;
	absolute_y = (gint) ((_tmp6_ - _tmp8_) / _tmp9_);
	_tmp10_ = self->priv->selection_rect;
	_tmp11_ = _tmp10_.width;
	_tmp12_ = self->priv->current_scale;
	absolute_w = (gint) (_tmp11_ / _tmp12_);
	_tmp13_ = self->priv->selection_rect;
	_tmp14_ = _tmp13_.height;
	_tmp15_ = self->priv->current_scale;
	absolute_h = (gint) (_tmp14_ / _tmp15_);
	_tmp16_ = self->priv->image;
	_tmp17_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, gdk_pixbuf_get_has_alpha (_tmp16_), 8, absolute_w, absolute_h);
	final_image = _tmp17_;
	_tmp18_ = self->priv->image;
	gdk_pixbuf_copy_area (_tmp18_, absolute_x, absolute_y, absolute_w, absolute_h, final_image, 0, 0);
	result = final_image;
	return result;
}


void
crop_widget_set_min_size (CropWidget* self,
                          gint min_width)
{
	g_return_if_fail (IS_CROP_WIDGET (self));
	self->priv->min_width = min_width;
}


CropWidget*
crop_widget_construct (GType object_type)
{
	CropWidget * self = NULL;
	self = (CropWidget*) g_object_new (object_type, NULL);
	return self;
}


CropWidget*
crop_widget_new (void)
{
	return crop_widget_construct (TYPE_CROP_WIDGET);
}


gdouble
crop_widget_get_desired_aspect_ratio (CropWidget* self)
{
	gdouble result;
	gdouble _tmp0_;
	g_return_val_if_fail (IS_CROP_WIDGET (self), 0.0);
	_tmp0_ = self->priv->_desired_aspect_ratio;
	result = _tmp0_;
	return result;
}


void
crop_widget_set_desired_aspect_ratio (CropWidget* self,
                                      gdouble value)
{
	g_return_if_fail (IS_CROP_WIDGET (self));
	if (crop_widget_get_desired_aspect_ratio (self) != value) {
		self->priv->_desired_aspect_ratio = value;
		g_object_notify_by_pspec ((GObject *) self, crop_widget_properties[CROP_WIDGET_DESIRED_ASPECT_RATIO_PROPERTY]);
	}
}


static gboolean
_crop_widget_mouse_motion_cb_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                             GdkEventMotion* event,
                                                             gpointer self)
{
	gboolean result;
	result = crop_widget_mouse_motion_cb ((CropWidget*) self, event);
	return result;
}


static void
_crop_widget_drag_gesture_begin_cb_gtk_gesture_drag_drag_begin (GtkGestureDrag* _sender,
                                                                gdouble start_x,
                                                                gdouble start_y,
                                                                gpointer self)
{
	crop_widget_drag_gesture_begin_cb ((CropWidget*) self, _sender, start_x, start_y);
}


static void
_crop_widget_drag_gesture_end_cb_gtk_gesture_drag_drag_end (GtkGestureDrag* _sender,
                                                            gdouble offset_x,
                                                            gdouble offset_y,
                                                            gpointer self)
{
	crop_widget_drag_gesture_end_cb ((CropWidget*) self, _sender, offset_x, offset_y);
}


static void
_crop_widget_drag_gesture_update_cb_gtk_gesture_drag_drag_update (GtkGestureDrag* _sender,
                                                                  gdouble offset_x,
                                                                  gdouble offset_y,
                                                                  gpointer self)
{
	crop_widget_drag_gesture_update_cb ((CropWidget*) self, _sender, offset_x, offset_y);
}


static GObject *
crop_widget_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CropWidget * self;
	GdkDisplay* _tmp0_;
	GdkCursor* _tmp1_;
	GdkDisplay* _tmp2_;
	GdkCursor* _tmp3_;
	GdkDisplay* _tmp4_;
	GdkCursor* _tmp5_;
	GtkGestureDrag* _tmp6_;
	GtkGestureDrag* _tmp7_;
	GtkGestureDrag* _tmp8_;
	GtkGestureDrag* _tmp9_;
	GtkGestureDrag* _tmp10_;
	parent_class = G_OBJECT_CLASS (crop_widget_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CROP_WIDGET, CropWidget);
	gtk_widget_set_events (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), (((gtk_widget_get_events (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget)) | GDK_POINTER_MOTION_MASK) | GDK_BUTTON1_MOTION_MASK) | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK);
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "motion-notify-event", (GCallback) _crop_widget_mouse_motion_cb_gtk_widget_motion_notify_event, self, 0);
	_tmp0_ = gtk_widget_get_display (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	_tmp1_ = gdk_cursor_new_for_display (_tmp0_, GDK_FLEUR);
	_g_object_unref0 (self->priv->drag_cursor);
	self->priv->drag_cursor = _tmp1_;
	_tmp2_ = gtk_widget_get_display (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	_tmp3_ = gdk_cursor_new_for_display (_tmp2_, GDK_ARROW);
	_g_object_unref0 (self->priv->default_cursor);
	self->priv->default_cursor = _tmp3_;
	_tmp4_ = gtk_widget_get_display (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	_tmp5_ = gdk_cursor_new_for_display (_tmp4_, GDK_BOTTOM_RIGHT_CORNER);
	_g_object_unref0 (self->priv->resize_cursor);
	self->priv->resize_cursor = _tmp5_;
	memset (&self->priv->image_rect, 0, sizeof (GdkRectangle));
	memset (&self->priv->selection_rect, 0, sizeof (GdkRectangle));
	_tmp6_ = (GtkGestureDrag*) gtk_gesture_drag_new (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	_g_object_unref0 (self->priv->drag_gesture);
	self->priv->drag_gesture = _tmp6_;
	_tmp7_ = self->priv->drag_gesture;
	gtk_gesture_single_set_button (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_gesture_single_get_type (), GtkGestureSingle), (guint) GDK_BUTTON_PRIMARY);
	_tmp8_ = self->priv->drag_gesture;
	g_signal_connect_object (_tmp8_, "drag-begin", (GCallback) _crop_widget_drag_gesture_begin_cb_gtk_gesture_drag_drag_begin, self, 0);
	_tmp9_ = self->priv->drag_gesture;
	g_signal_connect_object (_tmp9_, "drag-end", (GCallback) _crop_widget_drag_gesture_end_cb_gtk_gesture_drag_drag_end, self, 0);
	_tmp10_ = self->priv->drag_gesture;
	g_signal_connect_object (_tmp10_, "drag-update", (GCallback) _crop_widget_drag_gesture_update_cb_gtk_gesture_drag_drag_update, self, 0);
	return obj;
}


static void
crop_widget_class_init (CropWidgetClass * klass)
{
	crop_widget_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (CropWidgetPrivate));
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget *, cairo_t*)) crop_widget_real_draw;
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget *, GtkAllocation*)) crop_widget_real_size_allocate;
	G_OBJECT_CLASS (klass)->get_property = _vala_crop_widget_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_crop_widget_set_property;
	G_OBJECT_CLASS (klass)->constructor = crop_widget_constructor;
	G_OBJECT_CLASS (klass)->finalize = crop_widget_finalize;
	/**
	   * Ratio of the width to the height, i.e. (width/height)
	   * => values >1.0 for landscape pictures
	   */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CROP_WIDGET_DESIRED_ASPECT_RATIO_PROPERTY, crop_widget_properties[CROP_WIDGET_DESIRED_ASPECT_RATIO_PROPERTY] = g_param_spec_double ("desired-aspect-ratio", "desired-aspect-ratio", "desired-aspect-ratio", -G_MAXDOUBLE, G_MAXDOUBLE, 0.8, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void
crop_widget_instance_init (CropWidget * self)
{
	self->priv = CROP_WIDGET_GET_PRIVATE (self);
	self->priv->selection_grabbed = FALSE;
	self->priv->resize_area_grabbed = FALSE;
	self->priv->drag_diff_x = 0;
	self->priv->drag_diff_y = 0;
	self->priv->resize_diff_x = 0;
	self->priv->resize_diff_y = 0;
	self->priv->resize_area_hovered = FALSE;
	self->priv->current_scale = 1.0;
	self->priv->min_width = CROP_WIDGET_MIN_SIZE;
	self->priv->_desired_aspect_ratio = 0.8;
}


static void
crop_widget_finalize (GObject * obj)
{
	CropWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CROP_WIDGET, CropWidget);
	_g_object_unref0 (self->priv->drag_gesture);
	_g_object_unref0 (self->priv->image);
	_g_object_unref0 (self->priv->drag_cursor);
	_g_object_unref0 (self->priv->default_cursor);
	_g_object_unref0 (self->priv->resize_cursor);
	G_OBJECT_CLASS (crop_widget_parent_class)->finalize (obj);
}


GType
crop_widget_get_type (void)
{
	static volatile gsize crop_widget_type_id__volatile = 0;
	if (g_once_init_enter (&crop_widget_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CropWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) crop_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CropWidget), 0, (GInstanceInitFunc) crop_widget_instance_init, NULL };
		GType crop_widget_type_id;
		crop_widget_type_id = g_type_register_static (gtk_drawing_area_get_type (), "CropWidget", &g_define_type_info, 0);
		g_once_init_leave (&crop_widget_type_id__volatile, crop_widget_type_id);
	}
	return crop_widget_type_id__volatile;
}


static void
_vala_crop_widget_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	CropWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CROP_WIDGET, CropWidget);
	switch (property_id) {
		case CROP_WIDGET_DESIRED_ASPECT_RATIO_PROPERTY:
		g_value_set_double (value, crop_widget_get_desired_aspect_ratio (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_crop_widget_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	CropWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CROP_WIDGET, CropWidget);
	switch (property_id) {
		case CROP_WIDGET_DESIRED_ASPECT_RATIO_PROPERTY:
		crop_widget_set_desired_aspect_ratio (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



