/* MultiMediaWidget.c generated by valac 0.40.0, the Vala compiler
 * generated from MultiMediaWidget.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "CbMedia.h"
#include <float.h>
#include <math.h>


#define TYPE_MULTI_MEDIA_WIDGET (multi_media_widget_get_type ())
#define MULTI_MEDIA_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MULTI_MEDIA_WIDGET, MultiMediaWidget))
#define MULTI_MEDIA_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MULTI_MEDIA_WIDGET, MultiMediaWidgetClass))
#define IS_MULTI_MEDIA_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MULTI_MEDIA_WIDGET))
#define IS_MULTI_MEDIA_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MULTI_MEDIA_WIDGET))
#define MULTI_MEDIA_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MULTI_MEDIA_WIDGET, MultiMediaWidgetClass))

typedef struct _MultiMediaWidget MultiMediaWidget;
typedef struct _MultiMediaWidgetClass MultiMediaWidgetClass;
typedef struct _MultiMediaWidgetPrivate MultiMediaWidgetPrivate;

#define TYPE_MEDIA_BUTTON (media_button_get_type ())
#define MEDIA_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_BUTTON, MediaButton))
#define MEDIA_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_BUTTON, MediaButtonClass))
#define IS_MEDIA_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_BUTTON))
#define IS_MEDIA_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_BUTTON))
#define MEDIA_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_BUTTON, MediaButtonClass))

typedef struct _MediaButton MediaButton;
typedef struct _MediaButtonClass MediaButtonClass;
enum  {
	MULTI_MEDIA_WIDGET_0_PROPERTY,
	MULTI_MEDIA_WIDGET_NUM_PROPERTIES
};
static GParamSpec* multi_media_widget_properties[MULTI_MEDIA_WIDGET_NUM_PROPERTIES];
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
typedef struct _MediaButtonPrivate MediaButtonPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	MULTI_MEDIA_WIDGET_MEDIA_CLICKED_SIGNAL,
	MULTI_MEDIA_WIDGET_MEDIA_INVALID_SIGNAL,
	MULTI_MEDIA_WIDGET_NUM_SIGNALS
};
static guint multi_media_widget_signals[MULTI_MEDIA_WIDGET_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _MultiMediaWidget {
	GtkBox parent_instance;
	MultiMediaWidgetPrivate * priv;
	gboolean restrict_height;
	GtkWindow* window;
};

struct _MultiMediaWidgetClass {
	GtkBoxClass parent_class;
};

struct _MultiMediaWidgetPrivate {
	MediaButton** media_buttons;
	gint media_buttons_length1;
	gint _media_buttons_size_;
	gint media_count;
	gboolean media_invalid_fired;
};

struct _MediaButton {
	GtkWidget parent_instance;
	MediaButtonPrivate * priv;
	GtkWindow* window;
};

struct _MediaButtonClass {
	GtkWidgetClass parent_class;
};


static gpointer multi_media_widget_parent_class = NULL;

GType multi_media_widget_get_type (void) G_GNUC_CONST;
GType media_button_get_type (void) G_GNUC_CONST;
#define MULTI_MEDIA_WIDGET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MULTI_MEDIA_WIDGET, MultiMediaWidgetPrivate))
#define MULTI_MEDIA_WIDGET_MAX_HEIGHT 180
void multi_media_widget_set_all_media (MultiMediaWidget* self,
                                       CbMedia** medias,
                                       int medias_length1);
static void multi_media_widget_remove_all (MultiMediaWidget* self);
void multi_media_widget_set_media (MultiMediaWidget* self,
                                   gint index,
                                   CbMedia* media);
static void __lambda30_ (MultiMediaWidget* self,
                  GtkWidget* w);
static void ___lambda30__gfunc (gconstpointer data,
                         gpointer self);
MediaButton* media_button_new (CbMedia* media,
                               gboolean restrict_height);
MediaButton* media_button_construct (GType object_type,
                                     CbMedia* media,
                                     gboolean restrict_height);
void media_button_set_media (MediaButton* self,
                             CbMedia* value);
static void multi_media_widget_media_loaded_cb (MultiMediaWidget* self,
                                         CbMedia* source);
static void _multi_media_widget_media_loaded_cb_cb_media_progress (CbMedia* _sender,
                                                            gpointer self);
static void multi_media_widget_button_clicked_cb (MultiMediaWidget* self,
                                           MediaButton* source,
                                           gdouble px,
                                           gdouble py);
static void _multi_media_widget_button_clicked_cb_media_button_clicked (MediaButton* _sender,
                                                                 MediaButton* source,
                                                                 gdouble px,
                                                                 gdouble py,
                                                                 gpointer self);
CbMedia* media_button_get_media (MediaButton* self);
MultiMediaWidget* multi_media_widget_new (void);
MultiMediaWidget* multi_media_widget_construct (GType object_type);
static void g_cclosure_user_marshal_VOID__OBJECT_INT_DOUBLE_DOUBLE (GClosure * closure,
                                                             GValue * return_value,
                                                             guint n_param_values,
                                                             const GValue * param_values,
                                                             gpointer invocation_hint,
                                                             gpointer marshal_data);
static GObject * multi_media_widget_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void multi_media_widget_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


void
multi_media_widget_set_all_media (MultiMediaWidget* self,
                                  CbMedia** medias,
                                  int medias_length1)
{
	MediaButton** _tmp0_;
	g_return_if_fail (IS_MULTI_MEDIA_WIDGET (self));
	multi_media_widget_remove_all (self);
	_tmp0_ = g_new0 (MediaButton*, medias_length1 + 1);
	self->priv->media_buttons = (_vala_array_free (self->priv->media_buttons, self->priv->media_buttons_length1, (GDestroyNotify) g_object_unref), NULL);
	self->priv->media_buttons = _tmp0_;
	self->priv->media_buttons_length1 = medias_length1;
	self->priv->_media_buttons_size_ = self->priv->media_buttons_length1;
	self->priv->media_count = medias_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_;
				gint _tmp4_;
				CbMedia* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				CbMedia* _tmp8_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = i;
				if (!(_tmp3_ < medias_length1)) {
					break;
				}
				_tmp4_ = i;
				_tmp5_ = medias[_tmp4_];
				_vala_assert (_tmp5_ != NULL, "medias[i] != null");
				_tmp6_ = i;
				_tmp7_ = i;
				_tmp8_ = medias[_tmp7_];
				multi_media_widget_set_media (self, _tmp6_, _tmp8_);
			}
		}
	}
}


static void
__lambda30_ (MultiMediaWidget* self,
             GtkWidget* w)
{
	g_return_if_fail (GTK_IS_WIDGET (w));
	gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), w);
}


static void
___lambda30__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda30_ ((MultiMediaWidget*) self, (GtkWidget*) data);
}


static void
multi_media_widget_remove_all (MultiMediaWidget* self)
{
	GList* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (IS_MULTI_MEDIA_WIDGET (self));
	_tmp0_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer));
	_tmp1_ = _tmp0_;
	g_list_foreach (_tmp1_, ___lambda30__gfunc, self);
	_g_list_free0 (_tmp1_);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
_multi_media_widget_media_loaded_cb_cb_media_progress (CbMedia* _sender,
                                                       gpointer self)
{
	multi_media_widget_media_loaded_cb ((MultiMediaWidget*) self, _sender);
}


static void
_multi_media_widget_button_clicked_cb_media_button_clicked (MediaButton* _sender,
                                                            MediaButton* source,
                                                            gdouble px,
                                                            gdouble py,
                                                            gpointer self)
{
	multi_media_widget_button_clicked_cb ((MultiMediaWidget*) self, source, px, py);
}


void
multi_media_widget_set_media (MultiMediaWidget* self,
                              gint index,
                              CbMedia* media)
{
	gint _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	MediaButton* button = NULL;
	gboolean _tmp4_;
	MediaButton* _tmp5_;
	MediaButton* _tmp6_;
	MediaButton* _tmp7_;
	GtkWindow* _tmp8_;
	MediaButton** _tmp9_;
	gint _tmp9__length1;
	MediaButton* _tmp10_;
	MediaButton* _tmp11_;
	MediaButton* _tmp12_;
	gboolean _tmp13_;
	MediaButton* _tmp18_;
	MediaButton* _tmp19_;
	MediaButton* _tmp20_;
	g_return_if_fail (IS_MULTI_MEDIA_WIDGET (self));
	g_return_if_fail (CB_IS_MEDIA (media));
	_tmp0_ = self->priv->media_count;
	_vala_assert (index < _tmp0_, "index < media_count");
	_tmp2_ = media->loaded;
	if (_tmp2_) {
		gboolean _tmp3_;
		_tmp3_ = media->invalid;
		_tmp1_ = _tmp3_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		return;
	}
	_tmp4_ = self->restrict_height;
	_tmp5_ = media_button_new (NULL, _tmp4_);
	g_object_ref_sink (_tmp5_);
	button = _tmp5_;
	_tmp6_ = button;
	g_object_set_data_full (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, G_TYPE_OBJECT, GObject), "pos", (gpointer) ((gintptr) index), NULL);
	_tmp7_ = button;
	_tmp8_ = self->window;
	_tmp7_->window = _tmp8_;
	_tmp9_ = self->priv->media_buttons;
	_tmp9__length1 = self->priv->media_buttons_length1;
	_tmp10_ = button;
	_tmp11_ = _g_object_ref0 (_tmp10_);
	_g_object_unref0 (_tmp9_[index]);
	_tmp9_[index] = _tmp11_;
	_tmp12_ = _tmp9_[index];
	_tmp13_ = media->loaded;
	if (_tmp13_) {
		MediaButton** _tmp14_;
		gint _tmp14__length1;
		MediaButton* _tmp15_;
		_tmp14_ = self->priv->media_buttons;
		_tmp14__length1 = self->priv->media_buttons_length1;
		_tmp15_ = _tmp14_[index];
		media_button_set_media (_tmp15_, media);
	} else {
		MediaButton** _tmp16_;
		gint _tmp16__length1;
		MediaButton* _tmp17_;
		_tmp16_ = self->priv->media_buttons;
		_tmp16__length1 = self->priv->media_buttons_length1;
		_tmp17_ = _tmp16_[index];
		media_button_set_media (_tmp17_, media);
		g_signal_connect_object (media, "progress", (GCallback) _multi_media_widget_media_loaded_cb_cb_media_progress, self, 0);
	}
	_tmp18_ = button;
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, gtk_widget_get_type (), GtkWidget), TRUE);
	_tmp19_ = button;
	g_signal_connect_object (_tmp19_, "clicked", (GCallback) _multi_media_widget_button_clicked_cb_media_button_clicked, self, 0);
	_tmp20_ = button;
	gtk_box_pack_start (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_box_get_type (), GtkBox), G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, gtk_widget_get_type (), GtkWidget), TRUE, TRUE, (guint) 0);
	gtk_widget_queue_draw (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	_g_object_unref0 (button);
}


static void
multi_media_widget_button_clicked_cb (MultiMediaWidget* self,
                                      MediaButton* source,
                                      gdouble px,
                                      gdouble py)
{
	gboolean _tmp0_ = FALSE;
	CbMedia* _tmp1_;
	CbMedia* _tmp2_;
	g_return_if_fail (IS_MULTI_MEDIA_WIDGET (self));
	g_return_if_fail (IS_MEDIA_BUTTON (source));
	_tmp1_ = media_button_get_media (source);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != NULL) {
		CbMedia* _tmp3_;
		CbMedia* _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = media_button_get_media (source);
		_tmp4_ = _tmp3_;
		_tmp5_ = _tmp4_->loaded;
		_tmp0_ = _tmp5_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint index = 0;
		gconstpointer _tmp6_;
		CbMedia* _tmp7_;
		CbMedia* _tmp8_;
		gint _tmp9_;
		_tmp6_ = g_object_get_data (G_TYPE_CHECK_INSTANCE_CAST (source, G_TYPE_OBJECT, GObject), "pos");
		index = (gint) ((gintptr) _tmp6_);
		_tmp7_ = media_button_get_media (source);
		_tmp8_ = _tmp7_;
		_tmp9_ = index;
		g_signal_emit (self, multi_media_widget_signals[MULTI_MEDIA_WIDGET_MEDIA_CLICKED_SIGNAL], 0, _tmp8_, _tmp9_, px, py);
	}
}


static void
multi_media_widget_media_loaded_cb (MultiMediaWidget* self,
                                    CbMedia* source)
{
	gdouble _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (IS_MULTI_MEDIA_WIDGET (self));
	g_return_if_fail (CB_IS_MEDIA (source));
	_tmp0_ = source->percent_loaded;
	if (_tmp0_ < ((gdouble) 100)) {
		return;
	}
	_tmp1_ = source->invalid;
	if (_tmp1_) {
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp2_ = FALSE;
				_tmp2_ = TRUE;
				while (TRUE) {
					gint _tmp4_;
					gint _tmp5_;
					gboolean _tmp6_ = FALSE;
					MediaButton** _tmp7_;
					gint _tmp7__length1;
					gint _tmp8_;
					MediaButton* _tmp9_;
					if (!_tmp2_) {
						gint _tmp3_;
						_tmp3_ = i;
						i = _tmp3_ + 1;
					}
					_tmp2_ = FALSE;
					_tmp4_ = i;
					_tmp5_ = self->priv->media_count;
					if (!(_tmp4_ < _tmp5_)) {
						break;
					}
					_tmp7_ = self->priv->media_buttons;
					_tmp7__length1 = self->priv->media_buttons_length1;
					_tmp8_ = i;
					_tmp9_ = _tmp7_[_tmp8_];
					if (_tmp9_ != NULL) {
						MediaButton** _tmp10_;
						gint _tmp10__length1;
						gint _tmp11_;
						MediaButton* _tmp12_;
						CbMedia* _tmp13_;
						CbMedia* _tmp14_;
						_tmp10_ = self->priv->media_buttons;
						_tmp10__length1 = self->priv->media_buttons_length1;
						_tmp11_ = i;
						_tmp12_ = _tmp10_[_tmp11_];
						_tmp13_ = media_button_get_media (_tmp12_);
						_tmp14_ = _tmp13_;
						_tmp6_ = _tmp14_ == source;
					} else {
						_tmp6_ = FALSE;
					}
					if (_tmp6_) {
						MediaButton** _tmp15_;
						gint _tmp15__length1;
						gint _tmp16_;
						MediaButton* _tmp17_;
						MediaButton** _tmp18_;
						gint _tmp18__length1;
						gint _tmp19_;
						MediaButton* _tmp20_;
						gboolean _tmp21_;
						_tmp15_ = self->priv->media_buttons;
						_tmp15__length1 = self->priv->media_buttons_length1;
						_tmp16_ = i;
						_tmp17_ = _tmp15_[_tmp16_];
						gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_widget_get_type (), GtkWidget));
						_tmp18_ = self->priv->media_buttons;
						_tmp18__length1 = self->priv->media_buttons_length1;
						_tmp19_ = i;
						_g_object_unref0 (_tmp18_[_tmp19_]);
						_tmp18_[_tmp19_] = NULL;
						_tmp20_ = _tmp18_[_tmp19_];
						_tmp21_ = self->priv->media_invalid_fired;
						if (!_tmp21_) {
							g_signal_emit (self, multi_media_widget_signals[MULTI_MEDIA_WIDGET_MEDIA_INVALID_SIGNAL], 0);
							self->priv->media_invalid_fired = TRUE;
						}
						return;
					}
				}
			}
		}
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp22_ = FALSE;
			_tmp22_ = TRUE;
			while (TRUE) {
				gint _tmp24_;
				gint _tmp25_;
				gboolean _tmp26_ = FALSE;
				MediaButton** _tmp27_;
				gint _tmp27__length1;
				gint _tmp28_;
				MediaButton* _tmp29_;
				if (!_tmp22_) {
					gint _tmp23_;
					_tmp23_ = i;
					i = _tmp23_ + 1;
				}
				_tmp22_ = FALSE;
				_tmp24_ = i;
				_tmp25_ = self->priv->media_count;
				if (!(_tmp24_ < _tmp25_)) {
					break;
				}
				_tmp27_ = self->priv->media_buttons;
				_tmp27__length1 = self->priv->media_buttons_length1;
				_tmp28_ = i;
				_tmp29_ = _tmp27_[_tmp28_];
				if (_tmp29_ != NULL) {
					MediaButton** _tmp30_;
					gint _tmp30__length1;
					gint _tmp31_;
					MediaButton* _tmp32_;
					CbMedia* _tmp33_;
					CbMedia* _tmp34_;
					_tmp30_ = self->priv->media_buttons;
					_tmp30__length1 = self->priv->media_buttons_length1;
					_tmp31_ = i;
					_tmp32_ = _tmp30_[_tmp31_];
					_tmp33_ = media_button_get_media (_tmp32_);
					_tmp34_ = _tmp33_;
					_tmp26_ = _tmp34_ == source;
				} else {
					_tmp26_ = FALSE;
				}
				if (_tmp26_) {
					MediaButton** _tmp35_;
					gint _tmp35__length1;
					gint _tmp36_;
					MediaButton* _tmp37_;
					_tmp35_ = self->priv->media_buttons;
					_tmp35__length1 = self->priv->media_buttons_length1;
					_tmp36_ = i;
					_tmp37_ = _tmp35_[_tmp36_];
					gtk_widget_queue_draw (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, gtk_widget_get_type (), GtkWidget));
					break;
				}
			}
		}
	}
}


MultiMediaWidget*
multi_media_widget_construct (GType object_type)
{
	MultiMediaWidget * self = NULL;
	self = (MultiMediaWidget*) g_object_new (object_type, NULL);
	return self;
}


MultiMediaWidget*
multi_media_widget_new (void)
{
	return multi_media_widget_construct (TYPE_MULTI_MEDIA_WIDGET);
}


static void
g_cclosure_user_marshal_VOID__OBJECT_INT_DOUBLE_DOUBLE (GClosure * closure,
                                                        GValue * return_value,
                                                        guint n_param_values,
                                                        const GValue * param_values,
                                                        gpointer invocation_hint,
                                                        gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_INT_DOUBLE_DOUBLE) (gpointer data1, gpointer arg_1, gint arg_2, gdouble arg_3, gdouble arg_4, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_INT_DOUBLE_DOUBLE callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 5);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_INT_DOUBLE_DOUBLE) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_int (param_values + 2), g_value_get_double (param_values + 3), g_value_get_double (param_values + 4), data2);
}


static GObject *
multi_media_widget_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MultiMediaWidget * self;
	parent_class = G_OBJECT_CLASS (multi_media_widget_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MULTI_MEDIA_WIDGET, MultiMediaWidget);
	gtk_orientable_set_orientation (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_orientable_get_type (), GtkOrientable), GTK_ORIENTATION_HORIZONTAL);
	gtk_box_set_homogeneous (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_box_get_type (), GtkBox), TRUE);
	return obj;
}


static void
multi_media_widget_class_init (MultiMediaWidgetClass * klass)
{
	multi_media_widget_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MultiMediaWidgetPrivate));
	G_OBJECT_CLASS (klass)->constructor = multi_media_widget_constructor;
	G_OBJECT_CLASS (klass)->finalize = multi_media_widget_finalize;
	multi_media_widget_signals[MULTI_MEDIA_WIDGET_MEDIA_CLICKED_SIGNAL] = g_signal_new ("media-clicked", TYPE_MULTI_MEDIA_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_INT_DOUBLE_DOUBLE, G_TYPE_NONE, 4, CB_TYPE_MEDIA, G_TYPE_INT, G_TYPE_DOUBLE, G_TYPE_DOUBLE);
	multi_media_widget_signals[MULTI_MEDIA_WIDGET_MEDIA_INVALID_SIGNAL] = g_signal_new ("media-invalid", TYPE_MULTI_MEDIA_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void
multi_media_widget_instance_init (MultiMediaWidget * self)
{
	self->priv = MULTI_MEDIA_WIDGET_GET_PRIVATE (self);
	self->restrict_height = FALSE;
	self->priv->media_count = 0;
	self->priv->media_invalid_fired = FALSE;
}


static void
multi_media_widget_finalize (GObject * obj)
{
	MultiMediaWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MULTI_MEDIA_WIDGET, MultiMediaWidget);
	self->priv->media_buttons = (_vala_array_free (self->priv->media_buttons, self->priv->media_buttons_length1, (GDestroyNotify) g_object_unref), NULL);
	G_OBJECT_CLASS (multi_media_widget_parent_class)->finalize (obj);
}


GType
multi_media_widget_get_type (void)
{
	static volatile gsize multi_media_widget_type_id__volatile = 0;
	if (g_once_init_enter (&multi_media_widget_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MultiMediaWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) multi_media_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MultiMediaWidget), 0, (GInstanceInitFunc) multi_media_widget_instance_init, NULL };
		GType multi_media_widget_type_id;
		multi_media_widget_type_id = g_type_register_static (gtk_box_get_type (), "MultiMediaWidget", &g_define_type_info, 0);
		g_once_init_leave (&multi_media_widget_type_id__volatile, multi_media_widget_type_id);
	}
	return multi_media_widget_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



