/* ScrollWidget.c generated by valac 0.40.0, the Vala compiler
 * generated from ScrollWidget.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>


#define TYPE_SCROLL_WIDGET (scroll_widget_get_type ())
#define SCROLL_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SCROLL_WIDGET, ScrollWidget))
#define SCROLL_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SCROLL_WIDGET, ScrollWidgetClass))
#define IS_SCROLL_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SCROLL_WIDGET))
#define IS_SCROLL_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SCROLL_WIDGET))
#define SCROLL_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SCROLL_WIDGET, ScrollWidgetClass))

typedef struct _ScrollWidget ScrollWidget;
typedef struct _ScrollWidgetClass ScrollWidgetClass;
typedef struct _ScrollWidgetPrivate ScrollWidgetPrivate;
enum  {
	SCROLL_WIDGET_0_PROPERTY,
	SCROLL_WIDGET_END_DIFF_PROPERTY,
	SCROLL_WIDGET_SCROLLED_DOWN_PROPERTY,
	SCROLL_WIDGET_SCROLLED_UP_PROPERTY,
	SCROLL_WIDGET_NUM_PROPERTIES
};
static GParamSpec* scroll_widget_properties[SCROLL_WIDGET_NUM_PROPERTIES];
typedef struct _Block44Data Block44Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block45Data Block45Data;
enum  {
	SCROLL_WIDGET_SCROLLED_TO_START_SIGNAL,
	SCROLL_WIDGET_SCROLLED_TO_END_SIGNAL,
	SCROLL_WIDGET_NUM_SIGNALS
};
static guint scroll_widget_signals[SCROLL_WIDGET_NUM_SIGNALS] = {0};

struct _ScrollWidget {
	GtkScrolledWindow parent_instance;
	ScrollWidgetPrivate * priv;
};

struct _ScrollWidgetClass {
	GtkScrolledWindowClass parent_class;
};

struct _ScrollWidgetPrivate {
	gdouble upper_cache;
	gdouble value_cache;
	gint balance;
	gdouble _end_diff;
	gulong scroll_down_id;
	gulong scroll_up_id;
	gint64 start_time;
	gint64 end_time;
	gdouble transition_diff;
	gdouble transition_start_value;
};

struct _Block44Data {
	int _ref_count_;
	ScrollWidget* self;
	gboolean animate;
};

struct _Block45Data {
	int _ref_count_;
	ScrollWidget* self;
	gboolean animate;
};


static gpointer scroll_widget_parent_class = NULL;

#define TOP 1
#define BOTTOM 2
#define NONE 0
GType scroll_widget_get_type (void) G_GNUC_CONST;
#define SCROLL_WIDGET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SCROLL_WIDGET, ScrollWidgetPrivate))
static void scroll_widget_keep_upper_func (ScrollWidget* self);
static void scroll_widget_keep_value_func (ScrollWidget* self);
gdouble scroll_widget_get_end_diff (ScrollWidget* self);
void scroll_widget_balance_next_upper_change (ScrollWidget* self,
                                              gint mode);
void scroll_widget_scroll_up_next (ScrollWidget* self,
                                   gboolean animate,
                                   gboolean force_start);
static Block44Data* block44_data_ref (Block44Data* _data44_);
static void block44_data_unref (void * _userdata_);
#define TRANSITION_DURATION (200 * 1000)
static gboolean scroll_widget_scroll_up_tick_cb (ScrollWidget* self,
                                          GtkWidget* widget,
                                          GdkFrameClock* frame_clock);
static gboolean _scroll_widget_scroll_up_tick_cb_gtk_tick_callback (GtkWidget* widget,
                                                             GdkFrameClock* frame_clock,
                                                             gpointer self);
static void ___lambda16_ (Block44Data* _data44_);
static void ____lambda16__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
void scroll_widget_scroll_down_next (ScrollWidget* self,
                                     gboolean animate,
                                     gboolean force_wait);
static Block45Data* block45_data_ref (Block45Data* _data45_);
static void block45_data_unref (void * _userdata_);
static void __lambda17_ (Block45Data* _data45_);
static void ___lambda17__gtk_widget_size_allocate (GtkWidget* _sender,
                                            GtkAllocation* allocation,
                                            gpointer self);
gdouble ease_out_cubic (gdouble t);
ScrollWidget* scroll_widget_new (void);
ScrollWidget* scroll_widget_construct (GType object_type);
void scroll_widget_set_end_diff (ScrollWidget* self,
                                 gdouble value);
gboolean scroll_widget_get_scrolled_down (ScrollWidget* self);
gboolean scroll_widget_get_scrolled_up (ScrollWidget* self);
static GObject * scroll_widget_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void _scroll_widget_keep_upper_func_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void _scroll_widget_keep_value_func_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void scroll_widget_finalize (GObject * obj);
static void _vala_scroll_widget_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_scroll_widget_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);


static void
scroll_widget_keep_upper_func (ScrollWidget* self)
{
	gdouble upper = 0.0;
	GtkAdjustment* _tmp0_;
	GtkAdjustment* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gint _tmp4_;
	GtkAdjustment* _tmp14_;
	GtkAdjustment* _tmp15_;
	gdouble _tmp16_;
	gdouble _tmp17_;
	GtkAdjustment* _tmp18_;
	GtkAdjustment* _tmp19_;
	gdouble _tmp20_;
	gdouble _tmp21_;
	g_return_if_fail (IS_SCROLL_WIDGET (self));
	_tmp0_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
	_tmp1_ = _tmp0_;
	_tmp2_ = gtk_adjustment_get_upper (_tmp1_);
	_tmp3_ = _tmp2_;
	upper = _tmp3_;
	_tmp4_ = self->priv->balance;
	if (_tmp4_ == TOP) {
		gdouble inc = 0.0;
		gdouble _tmp5_;
		gdouble _tmp6_;
		GtkAdjustment* _tmp7_;
		GtkAdjustment* _tmp8_;
		GtkAdjustment* _tmp9_;
		GtkAdjustment* _tmp10_;
		gdouble _tmp11_;
		gdouble _tmp12_;
		gdouble _tmp13_;
		_tmp5_ = upper;
		_tmp6_ = self->priv->upper_cache;
		inc = _tmp5_ - _tmp6_;
		_tmp7_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
		_tmp8_ = _tmp7_;
		_tmp9_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
		_tmp10_ = _tmp9_;
		_tmp11_ = gtk_adjustment_get_value (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = inc;
		gtk_adjustment_set_value (_tmp10_, _tmp12_ + _tmp13_);
		self->priv->balance = NONE;
	}
	_tmp14_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
	_tmp15_ = _tmp14_;
	_tmp16_ = gtk_adjustment_get_upper (_tmp15_);
	_tmp17_ = _tmp16_;
	self->priv->upper_cache = _tmp17_;
	_tmp18_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
	_tmp19_ = _tmp18_;
	_tmp20_ = gtk_adjustment_get_value (_tmp19_);
	_tmp21_ = _tmp20_;
	self->priv->value_cache = _tmp21_;
}


static void
scroll_widget_keep_value_func (ScrollWidget* self)
{
	GtkAdjustment* _tmp0_;
	GtkAdjustment* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble max = 0.0;
	GtkAdjustment* _tmp8_;
	GtkAdjustment* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	GtkAdjustment* _tmp12_;
	GtkAdjustment* _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	GtkAdjustment* _tmp16_;
	GtkAdjustment* _tmp17_;
	gdouble _tmp18_;
	gdouble _tmp19_;
	gdouble _tmp20_;
	gdouble _tmp21_;
	gdouble upper = 0.0;
	GtkAdjustment* _tmp22_;
	GtkAdjustment* _tmp23_;
	gdouble _tmp24_;
	gdouble _tmp25_;
	gint _tmp26_;
	GtkAdjustment* _tmp36_;
	GtkAdjustment* _tmp37_;
	gdouble _tmp38_;
	gdouble _tmp39_;
	GtkAdjustment* _tmp40_;
	GtkAdjustment* _tmp41_;
	gdouble _tmp42_;
	gdouble _tmp43_;
	g_return_if_fail (IS_SCROLL_WIDGET (self));
	_tmp0_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
	_tmp1_ = _tmp0_;
	_tmp2_ = gtk_adjustment_get_value (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ < 10.0) {
		GtkAdjustment* _tmp4_;
		GtkAdjustment* _tmp5_;
		gdouble _tmp6_;
		gdouble _tmp7_;
		_tmp4_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
		_tmp5_ = _tmp4_;
		_tmp6_ = gtk_adjustment_get_value (_tmp5_);
		_tmp7_ = _tmp6_;
		g_signal_emit (self, scroll_widget_signals[SCROLL_WIDGET_SCROLLED_TO_START_SIGNAL], 0, _tmp7_);
	}
	_tmp8_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
	_tmp9_ = _tmp8_;
	_tmp10_ = gtk_adjustment_get_upper (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
	_tmp13_ = _tmp12_;
	_tmp14_ = gtk_adjustment_get_page_size (_tmp13_);
	_tmp15_ = _tmp14_;
	max = _tmp11_ - _tmp15_;
	_tmp16_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
	_tmp17_ = _tmp16_;
	_tmp18_ = gtk_adjustment_get_value (_tmp17_);
	_tmp19_ = _tmp18_;
	_tmp20_ = max;
	_tmp21_ = self->priv->_end_diff;
	if (_tmp19_ >= (_tmp20_ - _tmp21_)) {
		g_signal_emit (self, scroll_widget_signals[SCROLL_WIDGET_SCROLLED_TO_END_SIGNAL], 0);
	}
	_tmp22_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
	_tmp23_ = _tmp22_;
	_tmp24_ = gtk_adjustment_get_upper (_tmp23_);
	_tmp25_ = _tmp24_;
	upper = _tmp25_;
	_tmp26_ = self->priv->balance;
	if (_tmp26_ == BOTTOM) {
		gdouble inc = 0.0;
		gdouble _tmp27_;
		gdouble _tmp28_;
		GtkAdjustment* _tmp29_;
		GtkAdjustment* _tmp30_;
		GtkAdjustment* _tmp31_;
		GtkAdjustment* _tmp32_;
		gdouble _tmp33_;
		gdouble _tmp34_;
		gdouble _tmp35_;
		_tmp27_ = upper;
		_tmp28_ = self->priv->upper_cache;
		inc = _tmp27_ - _tmp28_;
		_tmp29_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
		_tmp30_ = _tmp29_;
		_tmp31_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
		_tmp32_ = _tmp31_;
		_tmp33_ = gtk_adjustment_get_value (_tmp32_);
		_tmp34_ = _tmp33_;
		_tmp35_ = inc;
		gtk_adjustment_set_value (_tmp32_, _tmp34_ - _tmp35_);
		self->priv->balance = NONE;
	}
	_tmp36_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
	_tmp37_ = _tmp36_;
	_tmp38_ = gtk_adjustment_get_upper (_tmp37_);
	_tmp39_ = _tmp38_;
	self->priv->upper_cache = _tmp39_;
	_tmp40_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
	_tmp41_ = _tmp40_;
	_tmp42_ = gtk_adjustment_get_value (_tmp41_);
	_tmp43_ = _tmp42_;
	self->priv->value_cache = _tmp43_;
}


void
scroll_widget_balance_next_upper_change (ScrollWidget* self,
                                         gint mode)
{
	g_return_if_fail (IS_SCROLL_WIDGET (self));
	self->priv->balance = mode;
}


/**
   * TODO: Update scroll_down_next
   * Scroll to the very top of the scrolled window once the next
   * size_allocate occurs.
   * This will use a transition if the correct Gtk+ settings is set
   * to true.
   *
   * @param animate    Whether to animate/transition the change or not (default: true)
   */
static Block44Data*
block44_data_ref (Block44Data* _data44_)
{
	g_atomic_int_inc (&_data44_->_ref_count_);
	return _data44_;
}


static void
block44_data_unref (void * _userdata_)
{
	Block44Data* _data44_;
	_data44_ = (Block44Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data44_->_ref_count_)) {
		ScrollWidget* self;
		self = _data44_->self;
		_g_object_unref0 (self);
		g_slice_free (Block44Data, _data44_);
	}
}


static gboolean
_scroll_widget_scroll_up_tick_cb_gtk_tick_callback (GtkWidget* widget,
                                                    GdkFrameClock* frame_clock,
                                                    gpointer self)
{
	gboolean result;
	result = scroll_widget_scroll_up_tick_cb ((ScrollWidget*) self, widget, frame_clock);
	return result;
}


static void
___lambda16_ (Block44Data* _data44_)
{
	ScrollWidget* self;
	gboolean _tmp0_ = FALSE;
	GtkSettings* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkAdjustment* _tmp16_;
	GtkAdjustment* _tmp17_;
	gulong _tmp18_;
	self = _data44_->self;
	_tmp1_ = gtk_settings_get_default ();
	g_object_get (_tmp1_, "gtk-enable-animations", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		_tmp0_ = _data44_->animate;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GdkFrameClock* _tmp4_;
		gint64 _tmp5_;
		GtkAdjustment* _tmp6_;
		GtkAdjustment* _tmp7_;
		gdouble _tmp8_;
		gdouble _tmp9_;
		GtkAdjustment* _tmp10_;
		GtkAdjustment* _tmp11_;
		gdouble _tmp12_;
		gdouble _tmp13_;
		_tmp4_ = gtk_widget_get_frame_clock (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
		self->priv->start_time = gdk_frame_clock_get_frame_time (_tmp4_);
		_tmp5_ = self->priv->start_time;
		self->priv->end_time = _tmp5_ + TRANSITION_DURATION;
		_tmp6_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
		_tmp7_ = _tmp6_;
		_tmp8_ = gtk_adjustment_get_value (_tmp7_);
		_tmp9_ = _tmp8_;
		self->priv->transition_diff = -_tmp9_;
		_tmp10_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
		_tmp11_ = _tmp10_;
		_tmp12_ = gtk_adjustment_get_value (_tmp11_);
		_tmp13_ = _tmp12_;
		self->priv->transition_start_value = _tmp13_;
		gtk_widget_add_tick_callback (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), _scroll_widget_scroll_up_tick_cb_gtk_tick_callback, g_object_ref (self), g_object_unref);
	} else {
		GtkAdjustment* _tmp14_;
		GtkAdjustment* _tmp15_;
		_tmp14_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
		_tmp15_ = _tmp14_;
		gtk_adjustment_set_value (_tmp15_, (gdouble) 0);
	}
	_tmp16_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
	_tmp17_ = _tmp16_;
	_tmp18_ = self->priv->scroll_up_id;
	g_signal_handler_disconnect (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, G_TYPE_OBJECT, GObject), _tmp18_);
	self->priv->scroll_up_id = (gulong) 0;
}


static void
____lambda16__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
	___lambda16_ (self);
}


void
scroll_widget_scroll_up_next (ScrollWidget* self,
                              gboolean animate,
                              gboolean force_start)
{
	Block44Data* _data44_;
	g_return_if_fail (IS_SCROLL_WIDGET (self));
	_data44_ = g_slice_new0 (Block44Data);
	_data44_->_ref_count_ = 1;
	_data44_->self = g_object_ref (self);
	_data44_->animate = animate;
	if (!gtk_widget_get_mapped (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget))) {
		GtkAdjustment* _tmp0_;
		GtkAdjustment* _tmp1_;
		_tmp0_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
		_tmp1_ = _tmp0_;
		gtk_adjustment_set_value (_tmp1_, (gdouble) 0);
		block44_data_unref (_data44_);
		_data44_ = NULL;
		return;
	}
	if (force_start) {
		gboolean _tmp2_ = FALSE;
		GtkSettings* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = gtk_settings_get_default ();
		g_object_get (_tmp3_, "gtk-enable-animations", &_tmp4_, NULL);
		_tmp5_ = _tmp4_;
		if (_tmp5_) {
			_tmp2_ = _data44_->animate;
		} else {
			_tmp2_ = FALSE;
		}
		if (_tmp2_) {
			GdkFrameClock* _tmp6_;
			gint64 _tmp7_;
			GtkAdjustment* _tmp8_;
			GtkAdjustment* _tmp9_;
			gdouble _tmp10_;
			gdouble _tmp11_;
			GtkAdjustment* _tmp12_;
			GtkAdjustment* _tmp13_;
			gdouble _tmp14_;
			gdouble _tmp15_;
			_tmp6_ = gtk_widget_get_frame_clock (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
			self->priv->start_time = gdk_frame_clock_get_frame_time (_tmp6_);
			_tmp7_ = self->priv->start_time;
			self->priv->end_time = _tmp7_ + TRANSITION_DURATION;
			_tmp8_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
			_tmp9_ = _tmp8_;
			_tmp10_ = gtk_adjustment_get_value (_tmp9_);
			_tmp11_ = _tmp10_;
			self->priv->transition_diff = -_tmp11_;
			_tmp12_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
			_tmp13_ = _tmp12_;
			_tmp14_ = gtk_adjustment_get_value (_tmp13_);
			_tmp15_ = _tmp14_;
			self->priv->transition_start_value = _tmp15_;
			gtk_widget_add_tick_callback (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), _scroll_widget_scroll_up_tick_cb_gtk_tick_callback, g_object_ref (self), g_object_unref);
		} else {
			GtkAdjustment* _tmp16_;
			GtkAdjustment* _tmp17_;
			_tmp16_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
			_tmp17_ = _tmp16_;
			gtk_adjustment_set_value (_tmp17_, (gdouble) 0);
		}
	} else {
		gulong _tmp18_;
		GtkAdjustment* _tmp27_;
		GtkAdjustment* _tmp28_;
		gulong _tmp29_;
		_tmp18_ = self->priv->scroll_up_id;
		if (_tmp18_ != ((gulong) 0)) {
			GtkAdjustment* _tmp19_;
			GtkAdjustment* _tmp20_;
			gdouble _tmp21_;
			gdouble _tmp22_;
			GtkAdjustment* _tmp23_;
			GtkAdjustment* _tmp24_;
			gdouble _tmp25_;
			gdouble _tmp26_;
			_tmp19_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
			_tmp20_ = _tmp19_;
			_tmp21_ = gtk_adjustment_get_value (_tmp20_);
			_tmp22_ = _tmp21_;
			self->priv->transition_diff = -_tmp22_;
			_tmp23_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
			_tmp24_ = _tmp23_;
			_tmp25_ = gtk_adjustment_get_value (_tmp24_);
			_tmp26_ = _tmp25_;
			self->priv->transition_start_value = _tmp26_;
			block44_data_unref (_data44_);
			_data44_ = NULL;
			return;
		}
		_tmp27_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
		_tmp28_ = _tmp27_;
		_tmp29_ = g_signal_connect_data (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, G_TYPE_OBJECT, GObject), "notify::upper", (GCallback) ____lambda16__g_object_notify, block44_data_ref (_data44_), (GClosureNotify) block44_data_unref, 0);
		self->priv->scroll_up_id = _tmp29_;
	}
	block44_data_unref (_data44_);
	_data44_ = NULL;
}


/**
   * Scroll to the very end of the scrolled window once the next
   * size_alocate occurs.
   * This will use a transition if the correct Gtk+ settings is set
   * to true
   *
   * @param animate Whether to animate/transition the change or not (default: true)
   * @param force_wait If this is set to true, we will wait for the next size_allocate
   *                   event, even if the widget is unmapped (default: false).
   */
static Block45Data*
block45_data_ref (Block45Data* _data45_)
{
	g_atomic_int_inc (&_data45_->_ref_count_);
	return _data45_;
}


static void
block45_data_unref (void * _userdata_)
{
	Block45Data* _data45_;
	_data45_ = (Block45Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data45_->_ref_count_)) {
		ScrollWidget* self;
		self = _data45_->self;
		_g_object_unref0 (self);
		g_slice_free (Block45Data, _data45_);
	}
}


static void
__lambda17_ (Block45Data* _data45_)
{
	ScrollWidget* self;
	gboolean _tmp0_ = FALSE;
	GtkSettings* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gulong _tmp32_;
	self = _data45_->self;
	_tmp1_ = gtk_settings_get_default ();
	g_object_get (_tmp1_, "gtk-enable-animations", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		_tmp0_ = _data45_->animate;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GdkFrameClock* _tmp4_;
		gint64 _tmp5_;
		GtkAdjustment* _tmp6_;
		GtkAdjustment* _tmp7_;
		gdouble _tmp8_;
		gdouble _tmp9_;
		GtkAdjustment* _tmp10_;
		GtkAdjustment* _tmp11_;
		gdouble _tmp12_;
		gdouble _tmp13_;
		GtkAdjustment* _tmp14_;
		GtkAdjustment* _tmp15_;
		gdouble _tmp16_;
		gdouble _tmp17_;
		GtkAdjustment* _tmp18_;
		GtkAdjustment* _tmp19_;
		gdouble _tmp20_;
		gdouble _tmp21_;
		_tmp4_ = gtk_widget_get_frame_clock (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
		self->priv->start_time = gdk_frame_clock_get_frame_time (_tmp4_);
		_tmp5_ = self->priv->start_time;
		self->priv->end_time = _tmp5_ + TRANSITION_DURATION;
		_tmp6_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
		_tmp7_ = _tmp6_;
		_tmp8_ = gtk_adjustment_get_upper (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
		_tmp11_ = _tmp10_;
		_tmp12_ = gtk_adjustment_get_page_size (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
		_tmp15_ = _tmp14_;
		_tmp16_ = gtk_adjustment_get_value (_tmp15_);
		_tmp17_ = _tmp16_;
		self->priv->transition_diff = (_tmp9_ - _tmp13_) - _tmp17_;
		_tmp18_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
		_tmp19_ = _tmp18_;
		_tmp20_ = gtk_adjustment_get_value (_tmp19_);
		_tmp21_ = _tmp20_;
		self->priv->transition_start_value = _tmp21_;
		gtk_widget_add_tick_callback (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), _scroll_widget_scroll_up_tick_cb_gtk_tick_callback, g_object_ref (self), g_object_unref);
	} else {
		GtkAdjustment* _tmp22_;
		GtkAdjustment* _tmp23_;
		GtkAdjustment* _tmp24_;
		GtkAdjustment* _tmp25_;
		gdouble _tmp26_;
		gdouble _tmp27_;
		GtkAdjustment* _tmp28_;
		GtkAdjustment* _tmp29_;
		gdouble _tmp30_;
		gdouble _tmp31_;
		_tmp22_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
		_tmp23_ = _tmp22_;
		_tmp24_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
		_tmp25_ = _tmp24_;
		_tmp26_ = gtk_adjustment_get_upper (_tmp25_);
		_tmp27_ = _tmp26_;
		_tmp28_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
		_tmp29_ = _tmp28_;
		_tmp30_ = gtk_adjustment_get_page_size (_tmp29_);
		_tmp31_ = _tmp30_;
		gtk_adjustment_set_value (_tmp23_, _tmp27_ - _tmp31_);
	}
	_tmp32_ = self->priv->scroll_down_id;
	g_signal_handler_disconnect (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), _tmp32_);
	self->priv->scroll_down_id = (gulong) 0;
}


static void
___lambda17__gtk_widget_size_allocate (GtkWidget* _sender,
                                       GtkAllocation* allocation,
                                       gpointer self)
{
	__lambda17_ (self);
}


void
scroll_widget_scroll_down_next (ScrollWidget* self,
                                gboolean animate,
                                gboolean force_wait)
{
	Block45Data* _data45_;
	gboolean _tmp0_ = FALSE;
	gulong _tmp11_;
	gulong _tmp12_;
	g_return_if_fail (IS_SCROLL_WIDGET (self));
	_data45_ = g_slice_new0 (Block45Data);
	_data45_->_ref_count_ = 1;
	_data45_->self = g_object_ref (self);
	_data45_->animate = animate;
	if (!gtk_widget_get_mapped (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget))) {
		_tmp0_ = !force_wait;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkAdjustment* _tmp1_;
		GtkAdjustment* _tmp2_;
		GtkAdjustment* _tmp3_;
		GtkAdjustment* _tmp4_;
		gdouble _tmp5_;
		gdouble _tmp6_;
		GtkAdjustment* _tmp7_;
		GtkAdjustment* _tmp8_;
		gdouble _tmp9_;
		gdouble _tmp10_;
		_tmp1_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
		_tmp2_ = _tmp1_;
		_tmp3_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
		_tmp4_ = _tmp3_;
		_tmp5_ = gtk_adjustment_get_upper (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
		_tmp8_ = _tmp7_;
		_tmp9_ = gtk_adjustment_get_page_size (_tmp8_);
		_tmp10_ = _tmp9_;
		gtk_adjustment_set_value (_tmp2_, _tmp6_ - _tmp10_);
		block45_data_unref (_data45_);
		_data45_ = NULL;
		return;
	}
	_tmp11_ = self->priv->scroll_down_id;
	if (_tmp11_ != ((gulong) 0)) {
		block45_data_unref (_data45_);
		_data45_ = NULL;
		return;
	}
	_tmp12_ = g_signal_connect_data (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "size-allocate", (GCallback) ___lambda17__gtk_widget_size_allocate, block45_data_ref (_data45_), (GClosureNotify) block45_data_unref, 0);
	self->priv->scroll_down_id = _tmp12_;
	block45_data_unref (_data45_);
	_data45_ = NULL;
}


static gboolean
scroll_widget_scroll_up_tick_cb (ScrollWidget* self,
                                 GtkWidget* widget,
                                 GdkFrameClock* frame_clock)
{
	gboolean result = FALSE;
	gint64 now = 0LL;
	gdouble t = 0.0;
	gint64 _tmp4_;
	gint64 _tmp5_;
	gdouble _tmp10_;
	GtkAdjustment* _tmp11_;
	GtkAdjustment* _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	gboolean _tmp16_ = FALSE;
	GtkAdjustment* _tmp17_;
	GtkAdjustment* _tmp18_;
	gdouble _tmp19_;
	gdouble _tmp20_;
	g_return_val_if_fail (IS_SCROLL_WIDGET (self), FALSE);
	g_return_val_if_fail (GTK_IS_WIDGET (widget), FALSE);
	g_return_val_if_fail (GDK_IS_FRAME_CLOCK (frame_clock), FALSE);
	if (!gtk_widget_get_mapped (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget))) {
		GtkAdjustment* _tmp0_;
		GtkAdjustment* _tmp1_;
		gdouble _tmp2_;
		gdouble _tmp3_;
		_tmp0_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
		_tmp1_ = _tmp0_;
		_tmp2_ = self->priv->transition_start_value;
		_tmp3_ = self->priv->transition_diff;
		gtk_adjustment_set_value (_tmp1_, _tmp2_ + _tmp3_);
		result = FALSE;
		return result;
	}
	now = gdk_frame_clock_get_frame_time (frame_clock);
	t = 1.0;
	_tmp4_ = now;
	_tmp5_ = self->priv->end_time;
	if (_tmp4_ < _tmp5_) {
		gint64 _tmp6_;
		gint64 _tmp7_;
		gint64 _tmp8_;
		gint64 _tmp9_;
		_tmp6_ = now;
		_tmp7_ = self->priv->start_time;
		_tmp8_ = self->priv->end_time;
		_tmp9_ = self->priv->start_time;
		t = (_tmp6_ - _tmp7_) / ((gdouble) (_tmp8_ - _tmp9_));
	}
	_tmp10_ = t;
	t = ease_out_cubic (_tmp10_);
	_tmp11_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
	_tmp12_ = _tmp11_;
	_tmp13_ = self->priv->transition_start_value;
	_tmp14_ = t;
	_tmp15_ = self->priv->transition_diff;
	gtk_adjustment_set_value (_tmp12_, _tmp13_ + (_tmp14_ * _tmp15_));
	_tmp17_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
	_tmp18_ = _tmp17_;
	_tmp19_ = gtk_adjustment_get_value (_tmp18_);
	_tmp20_ = _tmp19_;
	if (_tmp20_ <= ((gdouble) 0)) {
		_tmp16_ = TRUE;
	} else {
		gint64 _tmp21_;
		gint64 _tmp22_;
		_tmp21_ = now;
		_tmp22_ = self->priv->end_time;
		_tmp16_ = _tmp21_ >= _tmp22_;
	}
	if (_tmp16_) {
		gtk_widget_queue_draw (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}


ScrollWidget*
scroll_widget_construct (GType object_type)
{
	ScrollWidget * self = NULL;
	self = (ScrollWidget*) g_object_new (object_type, NULL);
	return self;
}


ScrollWidget*
scroll_widget_new (void)
{
	return scroll_widget_construct (TYPE_SCROLL_WIDGET);
}


gdouble
scroll_widget_get_end_diff (ScrollWidget* self)
{
	gdouble result;
	gdouble _tmp0_;
	g_return_val_if_fail (IS_SCROLL_WIDGET (self), 0.0);
	_tmp0_ = self->priv->_end_diff;
	result = _tmp0_;
	return result;
}


void
scroll_widget_set_end_diff (ScrollWidget* self,
                            gdouble value)
{
	g_return_if_fail (IS_SCROLL_WIDGET (self));
	if (scroll_widget_get_end_diff (self) != value) {
		self->priv->_end_diff = value;
		g_object_notify_by_pspec ((GObject *) self, scroll_widget_properties[SCROLL_WIDGET_END_DIFF_PROPERTY]);
	}
}


gboolean
scroll_widget_get_scrolled_down (ScrollWidget* self)
{
	gboolean result;
	GtkAdjustment* _tmp0_;
	GtkAdjustment* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	GtkAdjustment* _tmp4_;
	GtkAdjustment* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	GtkAdjustment* _tmp8_;
	GtkAdjustment* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	g_return_val_if_fail (IS_SCROLL_WIDGET (self), FALSE);
	_tmp0_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
	_tmp1_ = _tmp0_;
	_tmp2_ = gtk_adjustment_get_value (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
	_tmp5_ = _tmp4_;
	_tmp6_ = gtk_adjustment_get_upper (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
	_tmp9_ = _tmp8_;
	_tmp10_ = gtk_adjustment_get_page_size (_tmp9_);
	_tmp11_ = _tmp10_;
	result = _tmp3_ >= ((_tmp7_ - _tmp11_) - 5);
	return result;
}


gboolean
scroll_widget_get_scrolled_up (ScrollWidget* self)
{
	gboolean result;
	GtkAdjustment* _tmp0_;
	GtkAdjustment* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	g_return_val_if_fail (IS_SCROLL_WIDGET (self), FALSE);
	_tmp0_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
	_tmp1_ = _tmp0_;
	_tmp2_ = gtk_adjustment_get_value (_tmp1_);
	_tmp3_ = _tmp2_;
	result = _tmp3_ <= ((gdouble) 5);
	return result;
}


static void
_scroll_widget_keep_upper_func_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
	scroll_widget_keep_upper_func ((ScrollWidget*) self);
}


static void
_scroll_widget_keep_value_func_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
	scroll_widget_keep_value_func ((ScrollWidget*) self);
}


static GObject *
scroll_widget_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ScrollWidget * self;
	GtkAdjustment* _tmp0_;
	GtkAdjustment* _tmp1_;
	GtkAdjustment* _tmp2_;
	GtkAdjustment* _tmp3_;
	parent_class = G_OBJECT_CLASS (scroll_widget_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SCROLL_WIDGET, ScrollWidget);
	_tmp0_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
	_tmp1_ = _tmp0_;
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, G_TYPE_OBJECT, GObject), "notify::upper", (GCallback) _scroll_widget_keep_upper_func_g_object_notify, self, 0);
	_tmp2_ = gtk_scrolled_window_get_vadjustment (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
	_tmp3_ = _tmp2_;
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, G_TYPE_OBJECT, GObject), "notify::value", (GCallback) _scroll_widget_keep_value_func_g_object_notify, self, 0);
	return obj;
}


static void
scroll_widget_class_init (ScrollWidgetClass * klass)
{
	scroll_widget_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ScrollWidgetPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_scroll_widget_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_scroll_widget_set_property;
	G_OBJECT_CLASS (klass)->constructor = scroll_widget_constructor;
	G_OBJECT_CLASS (klass)->finalize = scroll_widget_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCROLL_WIDGET_END_DIFF_PROPERTY, scroll_widget_properties[SCROLL_WIDGET_END_DIFF_PROPERTY] = g_param_spec_double ("end-diff", "end-diff", "end-diff", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 200, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCROLL_WIDGET_SCROLLED_DOWN_PROPERTY, scroll_widget_properties[SCROLL_WIDGET_SCROLLED_DOWN_PROPERTY] = g_param_spec_boolean ("scrolled-down", "scrolled-down", "scrolled-down", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCROLL_WIDGET_SCROLLED_UP_PROPERTY, scroll_widget_properties[SCROLL_WIDGET_SCROLLED_UP_PROPERTY] = g_param_spec_boolean ("scrolled-up", "scrolled-up", "scrolled-up", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	scroll_widget_signals[SCROLL_WIDGET_SCROLLED_TO_START_SIGNAL] = g_signal_new ("scrolled-to-start", TYPE_SCROLL_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
	scroll_widget_signals[SCROLL_WIDGET_SCROLLED_TO_END_SIGNAL] = g_signal_new ("scrolled-to-end", TYPE_SCROLL_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void
scroll_widget_instance_init (ScrollWidget * self)
{
	self->priv = SCROLL_WIDGET_GET_PRIVATE (self);
	self->priv->balance = NONE;
	self->priv->_end_diff = (gdouble) 200;
}


static void
scroll_widget_finalize (GObject * obj)
{
	ScrollWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SCROLL_WIDGET, ScrollWidget);
	G_OBJECT_CLASS (scroll_widget_parent_class)->finalize (obj);
}


GType
scroll_widget_get_type (void)
{
	static volatile gsize scroll_widget_type_id__volatile = 0;
	if (g_once_init_enter (&scroll_widget_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ScrollWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) scroll_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScrollWidget), 0, (GInstanceInitFunc) scroll_widget_instance_init, NULL };
		GType scroll_widget_type_id;
		scroll_widget_type_id = g_type_register_static (gtk_scrolled_window_get_type (), "ScrollWidget", &g_define_type_info, 0);
		g_once_init_leave (&scroll_widget_type_id__volatile, scroll_widget_type_id);
	}
	return scroll_widget_type_id__volatile;
}


static void
_vala_scroll_widget_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	ScrollWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SCROLL_WIDGET, ScrollWidget);
	switch (property_id) {
		case SCROLL_WIDGET_END_DIFF_PROPERTY:
		g_value_set_double (value, scroll_widget_get_end_diff (self));
		break;
		case SCROLL_WIDGET_SCROLLED_DOWN_PROPERTY:
		g_value_set_boolean (value, scroll_widget_get_scrolled_down (self));
		break;
		case SCROLL_WIDGET_SCROLLED_UP_PROPERTY:
		g_value_set_boolean (value, scroll_widget_get_scrolled_up (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_scroll_widget_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	ScrollWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SCROLL_WIDGET, ScrollWidget);
	switch (property_id) {
		case SCROLL_WIDGET_END_DIFF_PROPERTY:
		scroll_widget_set_end_diff (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



