/* TextButton.c generated by valac 0.40.0, the Vala compiler
 * generated from TextButton.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>


#define TYPE_TEXT_BUTTON (text_button_get_type ())
#define TEXT_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TEXT_BUTTON, TextButton))
#define TEXT_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TEXT_BUTTON, TextButtonClass))
#define IS_TEXT_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TEXT_BUTTON))
#define IS_TEXT_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TEXT_BUTTON))
#define TEXT_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TEXT_BUTTON, TextButtonClass))

typedef struct _TextButton TextButton;
typedef struct _TextButtonClass TextButtonClass;
typedef struct _TextButtonPrivate TextButtonPrivate;
enum  {
	TEXT_BUTTON_0_PROPERTY,
	TEXT_BUTTON_NUM_PROPERTIES
};
static GParamSpec* text_button_properties[TEXT_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _TextButton {
	GtkButton parent_instance;
	TextButtonPrivate * priv;
};

struct _TextButtonClass {
	GtkButtonClass parent_class;
};


static gpointer text_button_parent_class = NULL;

GType text_button_get_type (void) G_GNUC_CONST;
TextButton* text_button_new (void);
TextButton* text_button_construct (GType object_type);
void text_button_set_markup (TextButton* self,
                             const gchar* text);
static GObject * text_button_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);


TextButton*
text_button_construct (GType object_type)
{
	TextButton * self = NULL;
	self = (TextButton*) g_object_new (object_type, NULL);
	return self;
}


TextButton*
text_button_new (void)
{
	return text_button_construct (TYPE_TEXT_BUTTON);
}


/**
   * Adds a GtkLabel to the Button using the given text as markup.
   * If the button already contains another child, that will either be replaced if it's
   * no instance of GtkLabel, or - if it's a GtkLabel already - be reused.
   *
   * @param text The markup to use(see pango markup)
   */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


void
text_button_set_markup (TextButton* self,
                        const gchar* text)
{
	GtkLabel* label = NULL;
	GtkWidget* child = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	GtkContainer* _tmp17_;
	GtkContainer* _tmp18_;
	g_return_if_fail (IS_TEXT_BUTTON (self));
	g_return_if_fail (text != NULL);
	label = NULL;
	_tmp0_ = gtk_bin_get_child (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_bin_get_type (), GtkBin));
	_tmp1_ = _g_object_ref0 (_tmp0_);
	child = _tmp1_;
	_tmp2_ = child;
	if (_tmp2_ != NULL) {
		GtkWidget* _tmp3_;
		_tmp3_ = child;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, gtk_label_get_type ())) {
			GtkWidget* _tmp4_;
			GtkLabel* _tmp5_;
			GtkLabel* _tmp6_;
			_tmp4_ = child;
			_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_label_get_type (), GtkLabel));
			_g_object_unref0 (label);
			label = _tmp5_;
			_tmp6_ = label;
			gtk_label_set_markup (_tmp6_, text);
		} else {
			GtkWidget* _tmp7_;
			GtkLabel* _tmp8_;
			_tmp7_ = child;
			gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), _tmp7_);
			_tmp8_ = (GtkLabel*) gtk_label_new (text);
			g_object_ref_sink (_tmp8_);
			_g_object_unref0 (label);
			label = _tmp8_;
		}
	} else {
		GtkLabel* _tmp9_;
		_tmp9_ = (GtkLabel*) gtk_label_new (text);
		g_object_ref_sink (_tmp9_);
		_g_object_unref0 (label);
		label = _tmp9_;
	}
	_tmp10_ = label;
	gtk_label_set_use_markup (_tmp10_, TRUE);
	_tmp11_ = label;
	gtk_label_set_justify (_tmp11_, GTK_JUSTIFY_CENTER);
	_tmp12_ = label;
	gtk_widget_set_valign (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_BASELINE);
	_tmp13_ = label;
	gtk_label_set_ellipsize (_tmp13_, PANGO_ELLIPSIZE_END);
	_tmp14_ = label;
	gtk_label_set_xalign (_tmp14_, (gfloat) 0);
	_tmp15_ = label;
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_widget_get_type (), GtkWidget), TRUE);
	_tmp16_ = label;
	_tmp17_ = gtk_widget_get_parent (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_widget_get_type (), GtkWidget));
	_tmp18_ = _tmp17_;
	if (_tmp18_ == NULL) {
		GtkLabel* _tmp19_;
		_tmp19_ = label;
		gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_widget_get_type (), GtkWidget));
	}
	_g_object_unref0 (child);
	_g_object_unref0 (label);
}


static GObject *
text_button_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TextButton * self;
	GtkStyleContext* _tmp0_;
	parent_class = G_OBJECT_CLASS (text_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TEXT_BUTTON, TextButton);
	_tmp0_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	gtk_style_context_add_class (_tmp0_, "text-only-button");
	return obj;
}


static void
text_button_class_init (TextButtonClass * klass)
{
	text_button_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = text_button_constructor;
}


static void
text_button_instance_init (TextButton * self)
{
}


GType
text_button_get_type (void)
{
	static volatile gsize text_button_type_id__volatile = 0;
	if (g_once_init_enter (&text_button_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TextButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) text_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TextButton), 0, (GInstanceInitFunc) text_button_instance_init, NULL };
		GType text_button_type_id;
		text_button_type_id = g_type_register_static (gtk_button_get_type (), "TextButton", &g_define_type_info, 0);
		g_once_init_leave (&text_button_type_id__volatile, text_button_type_id);
	}
	return text_button_type_id__volatile;
}



